#!/usr/bin/env php
<?php
// -*- coding: UTF-8 -*-
define('VERSION_PORTAIL','1.5'); //version actuelle du portail
define('VERSION_APPLI','15'); //indique le nombre de mises à jour disponibles dans le fichier "update_appli.php"
define('VERSION_ACADEMIE','4'); //indique le nombre de mises à jour académiques disponibles dans le fichier "update_appli_academie.php"

//classe qui gère les opérations utiles à l'installation : mysql/affichage
//recherche de certaines variables
require_once("class_outils.php");
$install = new outils();

//autres constantes globales
define('ABSPATH','/var/www/html/envole/');		
define('APPLI_NAME','EnvOLE');
define('APPLI_MODULE','envole');
//les paramètres de connexion qui seront affectés à l'application
define('DB_HOST', 'localhost');
define('DB_NAME','portal');
define('DB_USER','envole');
define('DB_PREFIX','ent');
define('DB_PASS',$install->genere_pwd());
define('FILE_CONNEXION','serverdata.php');

//variables
$create_user = false;
$create_base = false;

//initier le fichier de log
$install->start_log();

$install->echo_titre("Installation de ".APPLI_NAME);

//connexion mysql qui servira aux enregistrements et mises à jour
$pass_root = $install->genere_pwd();
`mysql --defaults-file=/etc/mysql/debian.cnf mysql -e "UPDATE user SET password=PASSWORD('$pass_root') WHERE user='root'; flush privileges;"`;
$install->afficher("\n"); 
$install->connect("localhost","root",$pass_root);

$install->echo_sstitre("Analyse de la base \"".DB_NAME."\" et des paramètres de connexion");

//la base "portal" est-elle installée ?
$fichier_connexion = ABSPATH.FILE_CONNEXION;
if(is_dir("/var/lib/mysql/".DB_NAME))
	{
	$install->afficher("La base \"".DB_NAME."\" est présente sur ce serveur.\n");
	if(!is_file($fichier_connexion))
		{
		$install->afficher("Le fichier de connexion est introuvable... il va être recréé\n");
		$create_user = true;
		}
	else
		{
		$install->afficher("Lecture des paramètres de connexion... ");
		require_once($fichier_connexion);
		$install->afficher("OK\n");
		//Et si ces paramètres étaient erronés ?
		if(!$install->test($dbHost,$dbUser,$dbPass,$dbName))
			{
			$install->afficher("Les paramètres sont incorrects... ils vont être mis à jour\n");
			$create_user = true;
			}
		}
	}
else
	{
	$install->afficher("La base \"".DB_NAME."\" n'est pas présente sur ce serveur... elle va être installée\n");
	$create_base = true;
	}

if($create_user || $create_base)
	{
	//création de la base "portal" et son contenu
	if($create_base)
		{
		$install->afficher("Création de la base \"".DB_NAME."\"... ");
		$install->query("CREATE DATABASE `".DB_NAME."`;");
		$install->afficher("OK\n");
		}

	//création de l'utilisateur de la base "portal"
	//si il existe déjà, le mot de passe est mis à jour
	$install->afficher("Création de l'utilisateur \"".DB_USER."\"... ");
	$install->query("GRANT ALL PRIVILEGES ON ".DB_NAME.".* TO '".DB_USER."'@'".DB_HOST."' IDENTIFIED BY '".DB_PASS."' WITH GRANT OPTION;");
	$install->afficher("OK\n");
	
	$install->afficher("Rechargement des privilèges... ");
	$install->query("flush privileges;");
	$install->afficher("OK\n");
	
	$install->afficher("Création du fichier de connexion... ");
	$file = fopen($fichier_connexion,'w');
	fwrite($file,"<?php\n");
	fwrite($file,"/**** Paramètres de connexion MySQL ****/\n");
	fwrite($file,"\$dbHost=\"".DB_HOST."\";\n");
	fwrite($file,"\$dbName=\"".DB_NAME."\";\n");
	fwrite($file,"\$dbUser=\"".DB_USER."\";\n");
	fwrite($file,"\$dbPass=\"".DB_PASS."\";\n");
	fwrite($file,"\$dbPfix=\"".DB_PREFIX."\";\n");
	fwrite($file,"?>\n");
	fclose($file);
	$install->resultat(is_file($fichier_connexion));
	exec("chown root:www-data ".$fichier_connexion);
	exec("chmod 640 ".$fichier_connexion);
	}

//faut-il installer les tables dans cette base ?
$install->query("show tables;",DB_NAME);
if(mysql_num_rows($install->requete)==0)
	{
	if(!$create_base)
		{
		$install->afficher("AVERTISSEMENT : La base existe mais elle est vide, son contenu va être réinstallé.\n");
		$create_base = true;
		}
	$install->echo_sstitre("Installation du contenu de la base \"".DB_NAME."\"");
	$install->afficher("Installation... ");
	if(!is_file(DIR_EXEC."install_".APPLI_MODULE.".php")) $install->echec("\nLe fichier \"".DIR_EXEC."install_".APPLI_MODULE.".php\" est introuvable -> Installation interrompue.\n\n");
	require_once(DIR_EXEC."install_".APPLI_MODULE.".php");
	install();
	$install->afficher("OK\n");
	}

//création des comptes méta
$install->echo_sstitre("Traitement des comptes méta servant de modèles");
$install->create_prof('Meta_eleve','--user "Meta_eleve" --mdp "meta_eleve" --prenom "1" --fnom "meta_eleve" --sexe 1 -M "local" --droits 0 --classe "autre" --quota 0');
$install->create_prof('Meta_prof','--user "Meta_prof" --mdp "meta_prof" --prenom "1" --fnom "meta_prof" --sexe 1 -M "local" --droits 0 --classe "autre" --quota 0');
$install->create_prof('Meta_perdir','--user "Meta_perdir" --mdp "meta_perdir" --prenom "1" --fnom "meta_perdir" --sexe 1 -M "local" --droits 0 --classe "autre" --quota 0');
$install->create_prof('Meta_parent','--user "Meta_parent" --mdp "meta_parent" --prenom "1" --fnom "meta_parent" --sexe 1 -M "local" --droits 0 --classe "autre" --quota 0');
$install->create_prof('Visiteur','--user "Visiteur" --mdp "Visiteur" --prenom "1" --fnom "visiteur" --sexe 1 -M "local" --droits 0 --classe "autre" --quota 0');
$install->creation_classes();
	
//création du groupe cel_admin
$install->echo_sstitre("Création du groupe \"cel_admin\"");
$install->afficher("En cours... ");
`getent group cel_admin &>/dev/null || /usr/sbin/smbldap-groupadd cel_admin`;
`id admin | grep -q cel_admin || /usr/sbin/smbldap-groupmod -m admin cel_admin`;
`id Meta_eleve | grep -q cel_admin || /usr/sbin/smbldap-groupmod -m Meta_eleve cel_admin`;
`id Meta_prof | grep -q cel_admin || /usr/sbin/smbldap-groupmod -m Meta_prof cel_admin`;
`id Meta_perdir | grep -q cel_admin || /usr/sbin/smbldap-groupmod -m Meta_perdir cel_admin`;
`id Visiteur | grep -q cel_admin || /usr/sbin/smbldap-groupmod -m Visiteur cel_admin`;
$install->afficher("OK\n");

//droits
$install->echo_sstitre("Traitement des droits");

$install->afficher("Sur le répertoire \"/envole/ressources\" maintenant remplacé par \"/ressources\"... ");
$dirRessources = ABSPATH."ressources";
if(is_dir($dirRessources))
	{
	//290611 : "ressources" est maintenant mis en place par "eole-posh" et "conf_scribe"
	//il faut que le groupe 'cel_admin' aient les droits en lecture/écriture + apache pour la gestion des chartes
	exec("chown -R www-data:cel_admin ".$dirRessources);
	exec("chmod 775 ".$dirRessources);
	exec("find ".$dirRessources." -type d -exec chmod 775 {} \;");
	exec("find ".$dirRessources." -type f -exec chmod 664 {} \;");
	$install->afficher("OK\n");
	}
else $install->echec("Ce répertoire n'existe pas -> Installation interrompue.\n\n");

$install->afficher("Sur le fichier \"config/conf_gestion_donnees.xml\"... ");
$gestion_xml = ABSPATH."config/conf_gestion_donnees.xml";
$gestion_modele = ABSPATH."config/conf_gestion_donnees_initial.xml";
if(!is_file($gestion_xml) && is_file($gestion_modele))
	{
	$install->afficher("installation... ");
	exec("cp ".$gestion_modele." ".$gestion_xml);
	}
if(!is_file($gestion_xml)) $install->echec("Le fichier n'existe pas et le modèle est introuvable -> Installation interrompue.\n\n");
exec("chown root:www-data ".$gestion_xml);
exec("chmod 660 ".$gestion_xml);
$install->afficher("OK\n");

//concernant le serveur CAS
$install->echo_sstitre("Fichiers de configuration pour la CASsification");
/*$install->afficher("Vérification des répertoires... ");
if(!is_dir("/usr/share/sso/app_filters")) mkdir("/usr/share/sso/app_filters");
if(!is_dir("/usr/share/sso/user_infos")) mkdir("/usr/share/sso/user_infos");
$install->afficher("OK\n");*/
$install->afficher("Traitement des fichiers... ");
$install->sed(DIR_FILES."cas.sso.ori",ABSPATH."cas/cas.sso","NOM_DOMAINE",CAS_DOMAINNAME); //fichier qui n'est plus utilisé
//vérification du fichier "local_apps.ini" et simple message d'avertissement si fichier corrompu
/*$local_apps_diff = false;
$local_apps_message = "";
if(!is_file(DIR_FILTER."local_apps.ini")) $install->sed(DIR_FILES."local_apps.ini",DIR_FILTER."local_apps.ini","NOM_DOMAINE",SCRIBE_ENVOLE_URL);
else
	{
	$local_apps = parse_ini_file(DIR_FILTER."local_apps.ini",true);
	if($local_apps[APPLI_MODULE] && $local_apps[APPLI_MODULE."2"])
		{
		$local_apps_message = "REMARQUE : Le fichier \"".DIR_FILTER."local_apps.ini\" était déjà correctement configuré pour ".APPLI_NAME.".\n";
		$local_apps_ori = parse_ini_file(DIR_FILES."local_apps.ini",true);
		foreach($local_apps_ori[APPLI_MODULE] as $key=>$value)
			{
			if($value=="NOM_DOMAINE") $value = SCRIBE_ENVOLE_URL;
			if($local_apps[APPLI_MODULE][$key]!=$value) $local_apps_diff = true;
			}
		foreach($local_apps_ori[APPLI_MODULE."2"] as $key=>$value)
			{
			if($value=="NOM_DOMAINE") $value = SCRIBE_ENVOLE_URL;
			if($local_apps[APPLI_MODULE."2"][$key]!=$value) $local_apps_diff = true;
			}
		if($local_apps_diff) $local_apps_message = "ATTENTION : Le fichier \"local_apps.ini\" présent dans \"".DIR_FILTER."\" semble corrompu pour le module ".APPLI_NAME.".\nEn cas de problème, effacer les parties \"[".APPLI_MODULE."]\" et \"[".APPLI_MODULE."2]\" avant de relancer l'installation.\n";
		}
	else $install->sed(DIR_FILES."local_apps.ini",DIR_FILTER."local_apps.ini","NOM_DOMAINE",SCRIBE_ENVOLE_URL,false);
	}
//fichiers de connexion au serveur CAS pour chacun des modules
if(!is_file(ABSPATH."cas/cas_cdt.php")) $install->sed(DIR_FILES."cas_cdt.php.ori",ABSPATH."cas/cas_cdt.php","DNS_ETAB",SCRIBE_ENVOLE_URL);
if(!is_file(ABSPATH."cas/cas_calendar.php")) $install->sed(DIR_FILES."cas_calendar.php.ori",ABSPATH."cas/cas_calendar.php","DNS_ETAB",SCRIBE_ENVOLE_URL);
if(!is_file(ABSPATH."cas/cas_grr.php")) $install->sed(DIR_FILES."cas_grr.php.ori",ABSPATH."cas/cas_grr.php","DNS_ETAB",SCRIBE_ENVOLE_URL);
if(!is_file(ABSPATH."cas/cas_wordpress.php")) $install->sed(DIR_FILES."cas_wordpress.php.ori",ABSPATH."cas/cas_wordpress.php","DNS_ETAB",SCRIBE_ENVOLE_URL);
if(!is_file(ABSPATH."cas/cas_wordpressmu.php")) $install->sed(DIR_FILES."cas_wordpressmu.php.ori",ABSPATH."cas/cas_worpdressmu.php","DNS_ETAB",SCRIBE_ENVOLE_URL);
if(!is_file(ABSPATH."cas/cas_kne.php")) $install->sed(DIR_FILES."cas_kne.php.ori",ABSPATH."cas/cas_kne.php","DNS_ETAB",SCRIBE_ENVOLE_URL);
if(!is_file(ABSPATH."cas/cas_sitetv.php")) $install->sed(DIR_FILES."cas_sitetv.php.ori",ABSPATH."cas/cas_sitetv.php","DNS_ETAB",SCRIBE_ENVOLE_URL);
if(!is_file(ABSPATH."cas/cas_cns.php")) $install->sed(DIR_FILES."cas_cns.php.ori",ABSPATH."cas/cas_cns.php","DNS_ETAB",SCRIBE_ENVOLE_URL);*/
$install->afficher("OK\n");
//if($local_apps_message != "") $install->afficher($local_apps_message);

//on relance me serveur sso
/*$install->afficher("Rechargement du serveur SSO... ");
`invoke-rc.d eole-sso restart`;	
$install->afficher("OK\n");*/

//concernant Piwik
$install->echo_sstitre("Installation de Piwik");
if(!is_dir("/var/lib/mysql/piwik"))
	{
	$install->afficher("Création de la base \"Piwik\"... ");
	$install->query("CREATE DATABASE `piwik`;");
	$install->afficher("OK\n");
	}
else $install->afficher("La base \"Piwik\" est déjà présente sur ce serveur.\n");
$create_piwik_user = true;
if(is_file("/var/www/html/piwik/config/config.ini.php"))
	{
	$install->afficher("Lecture des paramètres de connexion... ");
	$piwik_settings = parse_ini_file("/var/www/html/piwik/config/config.ini.php");
	$install->afficher("OK\n");
	//Et si ces paramètres étaient erronés ?
	if($install->test($piwik_settings["host"],$piwik_settings["username"],$piwik_settings["password"],$piwik_settings["dbname"])) $create_piwik_user = false;
	}
if($create_piwik_user)
	{
	$pass_piwik = $install->genere_pwd();
	$install->afficher("Création de l'utilisateur \"piwik\"... ");
	$install->query("GRANT ALL PRIVILEGES ON piwik.* TO 'piwik'@'localhost' IDENTIFIED BY '".$pass_piwik."' WITH GRANT OPTION;");
	$install->afficher("OK\n");

	$install->afficher("Rechargement des privilèges... ");
	$install->query("flush privileges;");
	$install->afficher("OK\n");

	$install->afficher("Création du fichier de connexion à piwik... ");
	$install->sed(DIR_FILES."config.ini.piwik.php.ori","/var/www/html/piwik/config/config.ini.php","PASS_PIWIK",$pass_piwik);
	`chown root:www-data /var/www/html/piwik/config/config.ini.php`;
	`chmod 640 /var/www/html/piwik/config/config.ini.php`;
	$install->afficher("OK\n");
	}
$install->query("show tables;","piwik");
if(mysql_num_rows($install->requete)==0)
	{
	$install->afficher("Insertion des données dans la base \"piwik\"... ");
	if(!is_file(DIR_EXEC."install_piwik.php")) $install->echec("\nLe fichier \"".DIR_EXEC."install_piwik.php\" est introuvable -> Installation interrompue.\n\n");
	require_once(DIR_EXEC."install_piwik.php");
	install_piwik();
	$install->afficher("OK\n");
	}
else $install->afficher("La base \"piwik\" contient déjà des tables.\n");
//déplacer en postinst...
/*$install->afficher("Mise en place des droits sur certains répertoires pour Piwik... ");
if(!is_dir("/var/www/html/piwik/")) $install->echec("\nLe répertoire \"/var/www/html/piwik/\" est introuvable -> Installation interrompue.\n\n");
`chown -R www-data:www-data /var/www/html/piwik`;
`chmod 777 /var/www/html/piwik/tmp`;
`chmod 777 /var/www/html/piwik/tmp/templates_c`;
`chmod 777 /var/www/html/piwik/tmp/cache`;
$install->afficher("OK\n");*/

//sauvegarde de la base avant toute mise à jour
$install->echo_sstitre("Sauvegarde des bases avant toute mise à jour");
$install->dump(DB_NAME);
$install->dump("piwik");
if(is_dir("/var/lib/mysql/cel_conf")) $install->dump("cel_conf");

//récupération de la version installée
if(is_dir("/var/lib/mysql/cel_conf")) define('OLD_VERSION','1.13');
else
	{
	$install->query("SELECT `value` FROM `".DB_PREFIX."ajaxp_settings` WHERE `param`='VERSION_PORTAIL' LIMIT 1;",DB_NAME);
	if(!empty($install->reponses)) define('OLD_VERSION',$install->reponses[0]["value"]);
	else $install->echec("\n\nImpossible de récupérer le numéro de la version installée actuellement -> Installation interrompue.\n\n");
	}

//accès aux applis dans la barre d'outils
$install->echo_sstitre("Activation ou non des applications");
$install->activate_appli("calendar",WEBCALENDAR);
$install->activate_appli("cdt",CDT);
$install->activate_appli("webshare",SCRIBE_ENVOLE_WEBSHARE);
$install->activate_appli("wordpress",WORDPRESS);
$install->activate_appli("grr",GRR);

//analyse des mises à jour disponibles
$install->echo_titre("Traitement des mises à jour éventuelles pour ".APPLI_NAME);

$install->afficher("\nNuméro de mise à jour indiqué dans la base : ");
if(is_dir("/var/lib/mysql/cel_conf")) $etape_maj = "0"; //la maj 0 n'est que pour les versions 1.13 ayant la base cel_conf au lieu de la table entajaxp_settings
else
	{
	$install->query("SELECT `value` FROM `".DB_PREFIX."ajaxp_settings` WHERE `param`='VERSION_".strtoupper(APPLI_MODULE)."' LIMIT 1;",DB_NAME);
	$etape_maj = $install->reponses[0]["value"];
	}
$install->afficher($etape_maj."\n");
if(!is_file(DIR_EXEC."update_".APPLI_MODULE.".php")) $install->echec("\nLe fichier \"".DIR_EXEC."update_".APPLI_MODULE.".php\" est introuvable -> Installation interrompue.\n\n");
require_once(DIR_EXEC."update_".APPLI_MODULE.".php");
update($etape_maj);

//partie académique
if(NOM_ACADEMIE!="Autre")
	{
	$install->echo_titre("Installation de la partie académique");
	
	$install->afficher("\nLecture du choix académique... ");
	$install->query("SELECT `value` FROM `".DB_PREFIX."ajaxp_settings` WHERE `param`='ACADEMIE' LIMIT 1;",DB_NAME);
	$portal_academie = $install->reponses[0]["value"];
	$install->afficher("\"".$portal_academie."\"\n");
	if($portal_academie==NOM_ACADEMIE)
		{
		$install->afficher("Numéro de mise à jour indiqué dans la base : ");
		$install->query("SELECT `value` FROM `".DB_PREFIX."ajaxp_settings` WHERE `param`='VERSION_".strtoupper(APPLI_MODULE)."_ACADEMIQUE' LIMIT 1;",DB_NAME);
		$etape_maj = $install->reponses[0]["value"];
		$install->afficher($etape_maj."\n");
		$file_academie = DIR_EXEC."update_".APPLI_MODULE."_".NOM_ACADEMIE.".php";
		if(is_file($file_academie))
			{
			require_once($file_academie);
			update_academie($etape_maj);
			}
		else $install->afficher("\nLe fichier \"".$file_academie."\" est introuvable -> Installation non prévue.\n");
		}
	else $install->afficher("L'académie \"".$portal_academie."\" inscrite dans la base \"".DB_NAME."\" ne correspond pas à celle spécifier sur le serveur(\"".NOM_ACADEMIE."\") -> Installation Impossible.\n");
	}
else $install->echo_titre("Aucun choix académique n'est précisé dans gen_config");

//si jamais le portail est installé sans contenu pour le meta_eleve(32), le meta_prof(31), le meta_perdir(38), prévoir une page vide
//fait par défaut pour l'admin(22) et le visiteur(28) à l'installation de la base
if($create_base)
	{
	$ar_metas = array(31,32,38);
	foreach($ar_metas as $meta)
		{
		$install->query("SELECT `id` FROM `".DB_PREFIX."ajaxp_templates` WHERE `user_id`=".$meta." LIMIT 1;",DB_NAME);
		if(empty($install->reponses))
			{
			$install->query("INSERT INTO ".DB_PREFIX."ajaxp_templates (title, wpage, dypage, maxic, hidden, torder, user_id, ref_id) VALUES 
			('Ma page d''accueil', 762, 5, '1~~|~~100%', 0, 1, ".$meta.", 0);",DB_NAME);
			}
		}
	}

//insertion du numéro de version de cette installation
$install->query("UPDATE `".DB_PREFIX."ajaxp_settings` SET value='".VERSION_PORTAIL."' WHERE `param`= 'VERSION_PORTAIL';",DB_NAME);

$install->echo_titre("Installation du portail EnvOLE terminée");

//on relance le serveur apache
#$install->echo_sstitre("Rechargement du serveur Apache");
#$install->afficher("Veuillez patienter...\n");
#echo `invoke-rc.d apache2 restart`;

$install->stop_log();	
?>
