<?php

//variables  communes
define('DIR_EXEC','/usr/share/envole/'); 
define('DIR_FILES','/etc/sysconfig/envole/');
define('DIR_LOG','/var/log/envole/');
define('DIR_BACKUP','/var/backups/envole/');
define('DIR_FILTER','/usr/share/sso/app_filters/');
define('DIR_INFOS','/usr/share/sso/user_infos/');
define('FILE_FILTER','local_apps.ini');	

//récupération des variables utiles du dico eole (repris de "/var/www/ead/ParseDico.php")
$ar_constantes = array
	(
	"numero_etab",
	"libelle_etab",
	"domaine_messagerie_etab",
	"scribe_envole_url",
	"nom_academie",
	"scribe_envole",
	"scribe_envole_webshare",
	//"scribe_envole_webcalendar",
	//"scribe_envole_cdt",
	//"scribe_envole_grr",
	//"scribe_envole_wordpress",
	"webcalendar",
	"cdt",
	"grr",
	"wordpress",
	"cas_domainname"
	);
$fp=popen("/usr/share/creole/parsedico.py","r");
while (!feof ($fp))
	{
	$ligne = fgets($fp, 4096);
	if ($pos=strpos($ligne,'='))
		{
		$key = substr($ligne,0,$pos);
		if(in_array($key,$ar_constantes))
			{
			$value = substr($ligne,$pos+2,-2);
			if($key=="scribe_envole_url") $value = strtolower($value); //problème de majuscules et le serveur CAS est sensible à la casse...
			define(strtoupper($key),$value);
			}
		}
	}
pclose($fp);

//différentes opérations effectuées pendant une installation
class outils
	{
	var $db_name = "";
	var $db_user = "";
	var $only_log = true; //dans ce cas, mettre au moins un message sur la console au démarrage (start_log) et à l'arrêt (stop_log) du script concerné
	
	var $error_message = array
		(
		0=>"Impossible de se connecter à la base de données -> Installation abandonnée.\n\n",
		1=>"Impossible de sélectionner la base de données -> Installation abandonnée.\n\n",
		2=>"La requête suivante a échoué : ",
		3=>"Echec de la fermeture de connexion\n\n"
		);

	function start_log()
		{
		if($this->only_log) echo "Configuration de ".APPLI_NAME."... ";
		if(!is_dir(DIR_LOG)) mkdir(DIR_LOG);
		$this->file_log = fopen(DIR_LOG."install-".APPLI_MODULE."-".date("dmy-His").".log","a");
		}

	function stop_log($echec=false)
		{
		$etat = $echec ? "ERREUR" : "OK";
		if($this->only_log) echo $etat."\n";
		fclose($this->file_log);
		}
		
	function connect($dbhost,$dbuser,$dbpassword,$dbname="")
		{
		if($this->db_conn) $this->echec("Une connexion est déjà en cours.");
		$this->db_user = $dbuser;
		$this->afficher("Ouverture d'une connexion mysql en tant que \"".$this->db_user."\"... ");
		$this->db_conn = @mysql_connect($dbhost,$dbuser,$dbpassword);
		if ($this->db_conn)
			{
			if($dbname!="") $this->select($dbname);
			$this->afficher("OK\n");
			}
		else $this->echec($this->error_message[0]);
		}
	
	function select($dbname)
		{
		if (!@mysql_select_db($dbname,$this->db_conn)) $this->echec($this->error_message[1]);
		else $this->db_name = $dbname;
		}
	
	function query($sql,$dbname="")
		{
		if($dbname!="" && $dbname!=$this->db_name) $this->select($dbname);
		$this->requete = @mysql_query(utf8_decode($sql),$this->db_conn);
		if (!$this->requete) $this->echec($this->error_message[2].$sql."\n\n");
		else
			{
			$n=0;
			$this->reponses = array();
			while($row = @mysql_fetch_array($this->requete))
				{
				foreach($row as $key=>$value) $this->reponses[$n][$key]=$value;
				$n++;
				}
			}
		}
	
	function close()
		{
		$this->afficher("Fermeture de la connexion mysql en tant que \"".$this->db_user."\"... ");
		if(@mysql_close($this->db_conn))
			{
			$this->db_conn = false;
			$this->db_name = "";
			$this->afficher("OK\n");
			}
		else $this->echec($this->error_message[3]);
		}
	
	//procédure indépendante pour vérifier des identifiants de connexion à une base de données
	function test($dbhost,$dbuser,$dbpassword,$dbname)
		{
		$this->afficher("Tentative de connexion mysql à la base \"".$dbname."\" en tant que \"".$dbuser."\"... ");
		$link_test = @mysql_connect($dbhost,$dbuser,$dbpassword);
		if ($link_test)
			{
			if(@mysql_select_db($dbname,$link_test))
				{
				$this->afficher("OK\n");
				@mysql_close($link_test);
				return true;
				}
			else
				{
				$this->afficher("Echec\n");
				@mysql_close($link_test);
				}
			}
		else $this->afficher("Echec\n");
		return false;
		}
	
	function genere_pwd($pass_length=12)
	  {
	  $chaine = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";
	  $pass = "";
	  $chaine_length = strlen($chaine);
	  for($i=1;$i<=$pass_length;$i++)
	      {
	      $char = mt_rand(0,$chaine_length-1);
	      $pass.=$chaine[$char];
	      }
	  return $pass;
	  }	

	//affichage des étapes de l'installation
	function echo_titre($text)
		{
		//un caractère accentué compte pour 2 en utf-8...
		$longueur = strlen(utf8_decode($text));
		$cadre = "\n+";
		for($i=0;$i<($longueur+4);$i++) $cadre .= "-";
		$cadre .= "+\n";
		$this->afficher($cadre."|  ".$text."  |".$cadre);
		}

	//affichage des sous-étapes de l'installation
	function echo_sstitre($text)
		{
		$this->afficher("\n---- ".$text." ----\n");
		}

	//test sur le résultat d'une action qui renvoit true/false, l'action ayant été annoncée par la methode "afficher"
	function resultat($bool)
		{
		if($bool) $this->afficher("OK\n");
		else $this->echec("Echec\n");
		}

	//à afficher en sortie et dans le fichier de log
	function afficher($text)
		{
		fwrite($this->file_log,$text);
		if(!$this->only_log) echo $text;
		}
		
	//interruption du script
	function echec($text)
		{
		$this->afficher($text,true);
		$this->stop_log(true);
		exit;
		}
	
	//remplacer un mot par un autre dans un fichier
	function sed($ori_file,$dest_file,$avant,$apres,$ecraser=true)
		{
		$texte = @file_get_contents($ori_file);
		if(!preg_match("/[[:alnum:]]/",$texte)) $this->echec("\nLa lecture du fichier \"".$ori_file."\" a échoué -> Installation interrompue.\n\n");
		$texte = str_replace($avant,$apres,$texte);
		if($ecraser) @file_put_contents($dest_file,$texte);
		else @file_put_contents($dest_file,$texte,FILE_APPEND);
		if(!is_file($dest_file)) $this->echec("\nLe traitement du fichier \"".$dest_file."\" a échoué -> Installation interrompue.\n\n");
		}

	//copier un fichier
	function copier($ori_file,$dest_file)
		{
		if (!copy($ori_file,$dest_file))
		$this->echec("\nLe traitement du fichier \"".$dest_file."\" a échoué -> Installation interrompue.\n\n");
		}
	
	//extraction du contenu d'une base de données (tables-vues-fonctions)
	//pas de prise en compte des procédures
	function dump($base)
		{
		$this->afficher("Création dans \"".DIR_BACKUP."\" d'un fichier de sauvegarde de la base \"".$base."\"... ");
		if(!is_dir(DIR_BACKUP)) mkdir(DIR_BACKUP);
		$this->file_backup = fopen(DIR_BACKUP.$base."-dump-".date("dmy-His").".sql","w");
		$this->select($base);
		$sql="SHOW TABLE STATUS;";
		$result=mysql_query($sql,$this->db_conn);
		if($result)
			{
			while($row=mysql_fetch_assoc($result))
				{
				$this->dump_table_structure($row["Name"],$row["Comment"]);
				if($row["Comment"]!="VIEW") $this->dump_table_data($row["Name"]);
				}
			}
		else fwrite($this->file_backup,"/*** Aucune table présente dans $data ***/\n\n");
		mysql_free_result($result);
		//problème de déconnexion rencontrée sur un cartable particulier, phénomène non expliqué, commenté car mis en place pour piwik et finalement pas indispensable
		/*
		$sql="SHOW FUNCTION STATUS;";
		$result=mysql_query($sql,$this->db_conn);
		if($result)
			{
			while($row=mysql_fetch_assoc($result))
				{
				if($row["Db"]==$base) $this->dump_function_structure($row["Name"]);
				}
			}
		else fwrite($this->file_backup,"/*** Aucune table présente dans $data ***\n\n");
		mysql_free_result($result);
		*/
		fclose($this->file_backup);
		$this->afficher("OK\n");
		}
	
	function dump_function_structure($function)
		{
		fwrite($this->file_backup,"/*** Structure de la fonction `$function` ***/\n");
		$sql="SHOW CREATE FUNCTION `$function`;";
		$result=mysql_query($sql,$this->db_conn);
		if($result)
			{
			if($row=mysql_fetch_assoc($result))
				{
				if($row['Create Function']) fwrite($this->file_backup,$row['Create Function'].";\n\n");
				}
			}
		mysql_free_result($result);
		}

	function dump_table_structure($table,$type)
		{
		if($type=="VIEW") fwrite($this->file_backup,"/*** Structure de la view `$table` ***/\n");
		else fwrite($this->file_backup,"/*** Structure de la table `$table` ***/\n");
		$sql="SHOW CREATE TABLE `$table`; ";
		$result=mysql_query($sql,$this->db_conn);
		if($result)
			{
			if($row=mysql_fetch_assoc($result))
				{
				if($row['Create Table']) fwrite($this->file_backup,$row['Create Table'].";\n\n");
				elseif($row['Create View']) fwrite($this->file_backup,$row['Create View'].";\n\n");
				}
			}
		mysql_free_result($result);
		}
	
	function dump_table_data($table)
		{
		$sql="SELECT * FROM `$table`;";
		$result=mysql_query($sql,$this->db_conn);
		if($result)
			{
			$num_rows=mysql_num_rows($result);
			$num_fields=mysql_num_fields($result);
			if($num_rows>0)
				{
				fwrite($this->file_backup,"/*** Contenu de la table `$table` ***/\n");
				$field_type=array();
				$i=0;
				while($i<$num_fields)
					{
					$meta=mysql_fetch_field($result, $i);
					array_push($field_type, $meta->type);
					$i++;
					}
				//print_r($field_type);
				fwrite($this->file_backup,"INSERT INTO `$table` VALUES\n");
				$index=0;
				while($row=mysql_fetch_row($result))
					{
					fwrite($this->file_backup,"(");
					for($i=0; $i<$num_fields; $i++)
						{
						if(is_null($row[$i])) fwrite($this->file_backup,"null");
						else
							{
							switch($field_type[$i])
								{
								case 'int':
									fwrite($this->file_backup,$row[$i]);
									break;
								case 'string':
								case 'blob' :
								default:
									fwrite($this->file_backup,"'".mysql_real_escape_string($row[$i],$this->db_conn)."'");
								}
							}
						if($i<$num_fields-1) fwrite($this->file_backup,",");
						}
					fwrite($this->file_backup,")");
					if($index<$num_rows-1) fwrite($this->file_backup,",");
					else fwrite($this->file_backup,";");
					fwrite($this->file_backup,"\n");
					$index++;
					}
				}
			else fwrite($this->file_backup,"/*** La table `$table` est vide de contenu ***/\n\n");
			}
		mysql_free_result($result);
		fwrite($this->file_backup,"\n\n");
		}
	
	//connexion ldap pour identifier les classes et créer le méta_classe si besoin
	function creation_classes()
		{
		$ldap_server="localhost";
		$ldap_port=389;
		$ds=ldap_connect($ldap_server,$ldap_port);
		if(!$ds) $this->echec("Erreur de connexion LDAP\n\n");
		$sr=ldap_search($ds,"o=gouv,c=fr","(objectclass=classe)");
		$info = ldap_get_entries($ds,$sr);
		$total = $info["count"];
		$this->afficher("Nombre de classes identifiées: ".$total."\n");
		for($i=0;$i<$total;$i++)
			{
			$classe = $info[$i]["cn"][0];
			$pass = $this->genere_pwd();
			$this->create_prof('Meta_classe_'.$classe,'--user "Meta_classe_'.$classe.'" --mdp "'.$pass.'" --prenom "1" --fnom "meta_classe_'.$classe.'" --sexe 1 -M "local" --droits 0 --classe "autre" --quota 0');
			}
		}

	//tentative de création d'un utilisateur "prof"
	function create_prof($user,$options)
		{
		$this->afficher("Vérification de l'utilisateur ".$user."... ");
		exec('id '.$user.' &>/dev/null || /usr/share/eole/backend/creation-prof.py '.$options.' 2>&1',$output);
		if (preg_match("/exists$/",$output[0])) $this->afficher("il est déjà présent dans l'annuaire\n");
		elseif(preg_match("/ajouté$/",$output[0])) $this->afficher("il a été créé avec succès\n");
		elseif(empty($output[0])) $this->afficher("OK\n");
		else $this->afficher($output[0]."\n");
		}
	
	//activation ou non d'une appli dans le portail
	function activate_appli($name,$activate)
		{
		$uppername = strtoupper($name);
		$this->query("SELECT * FROM `".DB_PREFIX."ajaxp_settings` WHERE `param`='APPLI_".$uppername."' LIMIT 1;",DB_NAME);
		if(!empty($this->reponses))
			{
			$id = $this->reponses[0]["id"];
			$appli = $this->reponses[0]["affichage"];
			$value = $this->reponses[0]["value"];
			if($activate=="oui" && $value=="inactive")
				{
				$this->afficher("Accès à l'application \"".$appli."\"... ");
				$this->query("UPDATE `".DB_PREFIX."ajaxp_settings` SET `value` = 'active' WHERE `id`=".$id." LIMIT 1;",DB_NAME);
				$this->afficher("OK\n");
				}
			elseif($activate!="oui" && $value=="active")
				{
				$this->afficher("Ne pas proposer l'accès à l'application \"".$appli."\"... ");
				$this->query("UPDATE `".DB_PREFIX."ajaxp_settings` SET `value` = 'inactive' WHERE `id`=".$id." LIMIT 1;",DB_NAME);
				$this->afficher("OK\n");
				}
			else $this->afficher("Aucun changment de configuration n'est nécessaire pour l'application \"".$name."\".\n");
			}
		else
			{
			if($activate=="oui")
				{
				$value = "active";
				$this->afficher("Enregistrement et accès à l'application \"".$name."\"... ");
				}
			else
				{
				$value = "inactive";
				$this->afficher("Enregistrement de l'application \"".$name."\" sans l'activer... ");
				}
			$this->query("INSERT INTO `".DB_PREFIX."ajaxp_settings` (`param`, `affichage`, `value`, `writable`, `visible`, `categorie`) VALUES 
			('APPLI_".$uppername."', '".$name."', '".$value."', 0, 0, 'Applications');",DB_NAME);
			$this->afficher("OK\n");
			}
		}
	}
?>
