<?php
// -*- coding: UTF-8 -*-
// utf-8 pour les affichages lors de l'installation mais les insertions en bases doivents être en iso-8859-1...
function install_piwik()
	{
	global $install;
	$ar_queries = array();
	
	$ar_queries[] = "
			CREATE TABLE `piwik_access` (
			  `login` varchar(20) NOT NULL,
			  `idsite` int(10) unsigned NOT NULL,
			  `access` varchar(10) default NULL,
			  PRIMARY KEY  (`login`,`idsite`)
			) ENGINE=MyISAM DEFAULT CHARSET=latin1;";
			
	$ar_queries[] = "
			CREATE TABLE `piwik_log_action` (
			  `idaction` int(10) unsigned NOT NULL auto_increment,
			  `name` varchar(255) NOT NULL,
			  `type` tinyint(3) unsigned default NULL,
			  PRIMARY KEY  (`idaction`),
			  KEY `index_idaction` (`idaction`)
			) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1;";
			
	$ar_queries[] = "
			CREATE TABLE `piwik_log_link_visit_action` (
			  `idlink_va` int(11) NOT NULL auto_increment,
			  `idvisit` int(10) unsigned NOT NULL,
			  `idaction` int(10) unsigned NOT NULL,
			  `idaction_ref` int(11) unsigned NOT NULL,
			  `time_spent_ref_action` int(10) unsigned NOT NULL,
			  PRIMARY KEY  (`idlink_va`),
			  KEY `index_idvisit` (`idvisit`)
			) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1;";
			
	$ar_queries[] = "
			CREATE TABLE `piwik_log_profiling` (
			  `query` text NOT NULL,
			  `count` int(10) unsigned default NULL,
			  `sum_time_ms` float default NULL,
			  UNIQUE KEY `query` (`query`(100))
			) ENGINE=MyISAM DEFAULT CHARSET=latin1;";
			
	$ar_queries[] = "
			CREATE TABLE `piwik_log_visit` (
			  `idvisit` int(10) unsigned NOT NULL auto_increment,
			  `idsite` int(10) unsigned NOT NULL,
			  `visitor_localtime` time NOT NULL,
			  `visitor_idcookie` char(32) NOT NULL,
			  `visitor_returning` tinyint(1) NOT NULL,
			  `visit_first_action_time` datetime NOT NULL,
			  `visit_last_action_time` datetime NOT NULL,
			  `visit_server_date` date NOT NULL,
			  `visit_exit_idaction` int(11) NOT NULL,
			  `visit_entry_idaction` int(11) NOT NULL,
			  `visit_total_actions` smallint(5) unsigned NOT NULL,
			  `visit_total_time` smallint(5) unsigned NOT NULL,
			  `referer_type` int(10) unsigned default NULL,
			  `referer_name` varchar(70) default NULL,
			  `referer_url` text NOT NULL,
			  `referer_keyword` varchar(255) default NULL,
			  `config_md5config` char(32) NOT NULL,
			  `config_os` char(3) NOT NULL,
			  `config_browser_name` varchar(10) NOT NULL,
			  `config_browser_version` varchar(20) NOT NULL,
			  `config_resolution` varchar(9) NOT NULL,
			  `config_color_depth` tinyint(2) unsigned NOT NULL,
			  `config_pdf` tinyint(1) NOT NULL,
			  `config_flash` tinyint(1) NOT NULL,
			  `config_java` tinyint(1) NOT NULL,
			  `config_director` tinyint(1) NOT NULL,
			  `config_quicktime` tinyint(1) NOT NULL,
			  `config_realplayer` tinyint(1) NOT NULL,
			  `config_windowsmedia` tinyint(1) NOT NULL,
			  `config_cookie` tinyint(1) NOT NULL,
			  `location_ip` bigint(11) NOT NULL,
			  `location_browser_lang` varchar(20) NOT NULL,
			  `location_country` char(3) NOT NULL,
			  `location_continent` char(3) NOT NULL,
			  `location_provider` varchar(100) default NULL,
			  `cel_rne` varchar(8) default NULL,
			  `cel_ip` varchar(20) default NULL,
			  `cel_user` varchar(50) default NULL,
			  `cel_provenance` varchar(30) default NULL,
			  PRIMARY KEY  (`idvisit`),
			  KEY `index_idsite` (`idsite`),
			  KEY `index_visit_server_date` (`visit_server_date`)
			) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1;";
			
	$ar_queries[] = "
			CREATE TABLE `piwik_logger_api_call` (
			  `idlogger_api_call` int(10) unsigned NOT NULL auto_increment,
			  `class_name` varchar(255) default NULL,
			  `method_name` varchar(255) default NULL,
			  `parameter_names_default_values` text,
			  `parameter_values` text,
			  `execution_time` float default NULL,
			  `caller_ip` bigint(20) default NULL,
			  `timestamp` timestamp NULL default NULL,
			  `returned_value` text,
			  PRIMARY KEY  (`idlogger_api_call`)
			) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1;";
			
	$ar_queries[] = "
			CREATE TABLE `piwik_logger_error` (
			  `idlogger_error` int(10) unsigned NOT NULL auto_increment,
			  `timestamp` timestamp NULL default NULL,
			  `message` text,
			  `errno` int(10) unsigned default NULL,
			  `errline` int(10) unsigned default NULL,
			  `errfile` varchar(255) default NULL,
			  `backtrace` text,
			  PRIMARY KEY  (`idlogger_error`)
			) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1;";
			
	$ar_queries[] = "
			CREATE TABLE `piwik_logger_exception` (
			  `idlogger_exception` int(10) unsigned NOT NULL auto_increment,
			  `timestamp` timestamp NULL default NULL,
			  `message` text,
			  `errno` int(10) unsigned default NULL,
			  `errline` int(10) unsigned default NULL,
			  `errfile` varchar(255) default NULL,
			  `backtrace` text,
			  PRIMARY KEY  (`idlogger_exception`)
			) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1;";
			
	$ar_queries[] = "
			CREATE TABLE `piwik_logger_message` (
			  `idlogger_message` int(10) unsigned NOT NULL auto_increment,
			  `timestamp` timestamp NULL default NULL,
			  `message` text,
			  PRIMARY KEY  (`idlogger_message`)
			) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1;";
			
	$ar_queries[] = "
			CREATE TABLE `piwik_site` (
			  `idsite` int(10) unsigned NOT NULL auto_increment,
			  `name` varchar(90) NOT NULL,
			  `main_url` varchar(255) NOT NULL,
			  `ts_created` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
			  `feedburnerName` varchar(100) default NULL,
			  PRIMARY KEY  (`idsite`)
			) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1;";
			
	$ar_queries[] = "
			CREATE TABLE `piwik_site_url` (
			  `idsite` int(10) unsigned NOT NULL,
			  `url` varchar(255) NOT NULL,
			  PRIMARY KEY  (`idsite`,`url`)
			) ENGINE=MyISAM DEFAULT CHARSET=latin1;";
			
	$ar_queries[] = "
			CREATE TABLE `piwik_user` (
			  `login` varchar(20) NOT NULL,
			  `password` char(32) NOT NULL,
			  `alias` varchar(45) NOT NULL,
			  `email` varchar(100) NOT NULL,
			  `token_auth` char(32) NOT NULL,
			  `date_registered` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
			  PRIMARY KEY  (`login`),
			  UNIQUE KEY `uniq_keytoken` (`token_auth`)
			) ENGINE=MyISAM DEFAULT CHARSET=latin1;";
			 
	$ar_queries[] = "
			CREATE TABLE `piwik_user_dashboard` (
			  `login` varchar(20) NOT NULL,
			  `iddashboard` int(11) NOT NULL,
			  `layout` text NOT NULL,
			  PRIMARY KEY  (`login`,`iddashboard`)
			) ENGINE=MyISAM DEFAULT CHARSET=latin1;";
			
	$ar_queries[] = "
			CREATE  FUNCTION `nb_provenance`(prov CHAR(15),visit DATE ,site INT,name  CHAR(30)) RETURNS int(11)
				READS SQL DATA
			BEGIN
			  DECLARE nb_prov INT;
			  SELECT count(*) INTO nb_prov FROM piwik_log_visit
				LEFT JOIN piwik_log_link_visit_action as t2 USING (idvisit)
					LEFT JOIN piwik_log_action as t3 USING (idaction)
				WHERE cel_provenance=prov AND visit_server_date = visit AND idsite = site AND t3.name= name ;
			  RETURN nb_prov;
			END;";
			
	$ar_queries[] = "
			CREATE  VIEW  `piwik`.`view_piwik_visit_action` AS (select `plv`.`idvisit` AS `plvidvisit`,`plv`.`idsite` AS `plvidsite`,`plv`.`visitor_localtime` AS `visitor_localtime`,`plv`.`visitor_idcookie` AS `visitor_idcookie`,`plv`.`visitor_returning` AS `visitor_returning`,`plv`.`visit_first_action_time` AS `visit_first_action_time`,`plv`.`visit_last_action_time` AS `visit_last_action_time`,`plv`.`visit_server_date` AS `visit_server_date`,`plv`.`visit_exit_idaction` AS `visit_exit_idaction`,`plv`.`visit_entry_idaction` AS `visit_entry_idaction`,`plv`.`visit_total_actions` AS `visit_total_actions`,`plv`.`visit_total_time` AS `visit_total_time`,`plv`.`referer_type` AS `referer_type`,`plv`.`referer_name` AS `referer_name`,`plv`.`referer_url` AS `referer_url`,`plv`.`referer_keyword` AS `referer_keyword`,`plv`.`config_md5config` AS `config_md5config`,`plv`.`config_os` AS `config_os`,`plv`.`config_browser_name` AS `config_browser_name`,`plv`.`config_browser_version` AS `config_browser_version`,`plv`.`config_resolution` AS `config_resolution`,`plv`.`config_color_depth` AS `config_color_depth`,`plv`.`config_pdf` AS `config_pdf`,`plv`.`config_flash` AS `config_flash`,`plv`.`config_java` AS `config_java`,`plv`.`config_director` AS `config_director`,`plv`.`config_quicktime` AS `config_quicktime`,`plv`.`config_realplayer` AS `config_realplayer`,`plv`.`config_windowsmedia` AS `config_windowsmedia`,`plv`.`config_cookie` AS `config_cookie`,`plv`.`location_ip` AS `location_ip`,`plv`.`location_browser_lang` AS `location_browser_lang`,`plv`.`location_country` AS `location_country`,`plv`.`location_continent` AS `location_continent`,`plv`.`location_provider` AS `location_provider`,`plv`.`cel_rne` AS `cel_rne`,`plv`.`cel_ip` AS `cel_ip`,`plv`.`cel_user` AS `cel_user`,`plv`.`cel_provenance` AS `cel_provenance`,`pllva`.`idlink_va` AS `idlink_va`,`pllva`.`idvisit` AS `idvisit`,`pllva`.`idaction` AS `pllvaidaction`,`pllva`.`idaction_ref` AS `idaction_ref`,`pllva`.`time_spent_ref_action` AS `time_spent_ref_action`,`pla`.`idaction` AS `plaidaction`,`pla`.`name` AS `planame`,`pla`.`type` AS `platype`,`pla2`.`idaction` AS `pla2idaction`,`pla2`.`name` AS `pla2name`,`pla2`.`type` AS `pla2type` from (((`piwik_log_visit` `plv` join `piwik_log_link_visit_action` `pllva` on((`plv`.`idvisit` = `pllva`.`idvisit`))) join `piwik_log_action` `pla` on((`pllva`.`idaction` = `pla`.`idaction`))) left join `piwik_log_action` `pla2` on((`pla2`.`idaction` = `pllva`.`idaction_ref`))));";
			
	$ar_queries[] = "
			INSERT INTO `piwik_access` VALUES ('anonymous',1,'view');";
			
	$ar_queries[] = "
			INSERT INTO `piwik_access` VALUES ('admin',1,'admin');";
			
	$ar_queries[] = "
			INSERT INTO `piwik_user` (`login`, `password`, `alias`, `email`, `token_auth`, `date_registered`) VALUES 
			('anonymous', '', 'anonymous', 'anonymous@email.fr', 'anonymous', now());";
			
	$ar_queries[] = "
			INSERT INTO `piwik_user` (`login`, `password`, `alias`, `email`, `token_auth`, `date_registered`) VALUES 
			('admin', '', 'admin', '', 'token_auth', now());";
			
	$ar_queries[] = "
			INSERT INTO `piwik_site` (`idsite`, `name`, `main_url`, `ts_created`, `feedburnerName`) VALUES 
			(1, 'envole', 'http://127.0.0.1/piwik', '2008-09-22 00:00:00', NULL);";
			
	foreach($ar_queries as $requete) $install->query($requete,"piwik");
	}

?>