<?php
/*---------------------------------------------------+
| Licence : CeCILL v2
| Copyright (C) 2008 - Acadmie de Crteil
| Remerciements  Angel Stoitsov et Mario Stoitsov
+----------------------------------------------------+
| Historique
| Auteur : Date : Modification
| cdeseure : 17/12/2008 : intgration de l'outil de changement de mot de passe propos par l'quipe de Lille -> fonction changePWD
| cdeseure : 14/01/2009 : amlioration de l'hritage des environnements (avec ajout d'un champ 'ref_id' dans les tables 'templates' et 'boxes')
| cdeseure : 05/2009 : gestion spcifique pour des contenus prdfinis type ressources avec/sans abonnement -> voir adminAddContenuMenu et adminEditContenuMenu
| cdeseure : 05/2009 : gestion de l'affichage des images disponibles dont ajout de la fonction getImgRessources() -> voir adminAddContenuMenu et adminEditContenuMenu
| cdeseure : 05/2009 : partage de contenus -> voir adminAddContenuMenu et adpLookup pour grer l'import et nouvelle fonction getBoxInfos pour l'export
| cdeseure : 05/2009 : partage de contenus -> ajout d'une tape pour importer ou non l'icne ventuelle associe  un contenu (voir adpLookup et getImgSharebox)
| cdeseure : 09/2009 : modification de changeText() pour permettre l'insertion de html dans le contenu d'une bote
| cdeseure : 03/2010 : ajout de setEleve() et setEleves() pour grer l'environnement responsable
+----------------------------------------------------*/


//pour enregistrer l'lve slectionn (voir ajaxp_template/ajaxp_template.php)
function setEleve($key)
	{
	if(isset($_SESSION["sess_eleves"]) && is_array($_SESSION["sess_eleves"]) && array_key_exists($key,$_SESSION["sess_eleves"]))
		{
		$_SESSION["sess_eleve"] = $key;
		return 1;
		}
	else return 0;
	}

//pour enregistrer les enfants d'un responsable en session lors de sa connexion (voir loginCAS.php)
function setEleves($eleves)
	{
	$_SESSION["sess_eleves"] = array();
	sort($eleves);
	
	$ldap_server = "localhost";
	$ldap_port = 389;
	$ldap_dn = "o=gouv,c=fr";
	$ldap_civilite = array(1=>"M.",2=>"MME",3=>"MLLE");
	$ldap_eleve_attr = array
		(
		'uid',          //login
		'sn',           //nom
		'givenname',    //prnom
		'codecivilite', //civilite
		'divcod'        //classe
		);

	$ldapconn = @ldap_connect($ldap_server,$ldap_port);
	if ($ldapconn)
		{
		$ldapbind = @ldap_bind($ldapconn);
		if ($ldapbind)
			{
			foreach($eleves as $eleve)
				{
				$ldapsearch = @ldap_search($ldapconn,$ldap_dn,"(&(objectclass=entEleve)(uid=".$eleve."))",$ldap_eleve_attr);
				if ($ldapsearch)
					{
					$infos = @ldap_get_entries($ldapconn,$ldapsearch);
					if (isset($infos['count']) && $infos['count']>0)
						{
						$civ_id = $infos[0][$ldap_eleve_attr[3]][0];
						$_SESSION["sess_eleves"][] = array
							(
							"login" => $infos[0][$ldap_eleve_attr[0]][0],
							"nom" => $infos[0][$ldap_eleve_attr[1]][0],
							"prenom" => $infos[0][$ldap_eleve_attr[2]][0],
							"civilite" => $ldap_civilite[$civ_id],
							"classe" => $infos[0][$ldap_eleve_attr[4]][0]
							);
						}
					@ldap_free_result($ldapsearch);
					}
				}
			if(!empty($_SESSION["sess_eleves"])) $_SESSION["sess_eleve"] = 0; //lve slectionn par dfaut
			}
		}	
	}

//pour scuriser les insertions en base de donnes
function security($var,$action=NULL)
	{
	switch($action)
		{
		//protge l'insertion de code javascript et html
		case'1':
		$var = preg_replace('/(?:<script.*?>)((\n|\r|.)*?)(?:<\/script>)/','', $var);
		$var = strip_tags($var);	
		break;
		
		// scurise les variables avant injection SQL
		case'2':
		if(get_magic_quotes_gpc()) $var = stripslashes($var);
		$var = mysql_real_escape_string($var);
		break;
				
		//Vrifie les entiers (0 par dfaut)
		case'3':
		$var = intval($var);
		break;
	
		//Combine le case '1' et le case '2'
		default:
		$var = preg_replace('/(?:<script.*?>)((\n|\r|.)*?)(?:<\/script>)/','', $var);
		$var = strip_tags($var);
		if(get_magic_quotes_gpc()) $var = stripslashes($var);
		$var = mysql_real_escape_string($var);
		break;
		}
	return $var;
	}

//rcupre les informations d'une bote pour qu'elles puissent tre envoyes vers un autre portail
function getBoxInfos($box_id)
	{
	$box_id = intval($box_id);
	$query_select = "SELECT `title`,`content`,`type` FROM  `".PREFIX."ajaxp_boxes` WHERE bid='".$box_id."' LIMIT 1;";
	$result_select = mysql_query($query_select);
	$row=mysql_fetch_assoc($result_select);
	if($row)
		{
		extract($row);
		switch($type) //ne connaissant pas le menu d'o a t cr ce contenu, il faut retrouver le lien pour qu'il soit reconstruit par le portail de destination
			{
			case "inBox" :
			$detection_url = preg_match("/,'([^']+)'\);/i",$content,$matches_url);
			$detection_img = preg_match('/<img.*src="([^"]+)".*>/i',$content,$matches_img);
			$detection_height = false;
			break;
			case "outBox" :
			$detection_url = preg_match('/href="([^"]+)"/i',$content,$matches_url);
			$detection_img = preg_match('/<img.*src="([^"]+)".*>/i',$content,$matches_img);
			$detection_height = false;
			break;
			case "htmlBox" :
			$detection_url = preg_match('/src="([^"]+)"/i',$content,$matches_url);
			$detection_img = false;
			$detection_height = preg_match('/height="([^"]+)"/i',$content,$matches_height);
			break;
			case "newsBox" :
			$detection_url = preg_match('/src="custom\/rss2html\.php\?rss_url=([^"]+)"/i',$content,$matches_url);
			$detection_img = false;
			$detection_height = preg_match('/height="([^"]+)"/i',$content,$matches_height);
			break;
			default :
			return false;
			break;
			}
		if($detection_url===false || $detection_url===0) return false;
		else
			{
			$query_string = "newbox=".$type."&boxTitle=".urlencode($title)."&boxParam=".urlencode($matches_url[1]);
			if($detection_img==1) //envoyer une url complte de l'image
				{
				$path = $matches_img[1];
				if(preg_match("#^http#i",$path)) $boxImg = $path; //url dj complte
				else
					{
					if((isset($_SERVER["SERVER_PORT"]) && $_SERVER["SERVER_PORT"]=="443") || (isset($_SERVER["HTTPS"]) && $_SERVER["HTTPS"]=="on")) $boxImg = "https://";
					else $boxImg = "http://";
					$boxImg .= $_SERVER["SERVER_NAME"];
					if(strpos($path,"/")===0) $boxImg .= $path; //chemin absolue d'une image
					elseif(strpos($path,"../")===0) $boxImg .= preg_replace("/^\.\./","",$path); //chemin relatif d'une image
					else  $boxImg .= "/envole/".$path; //chemin dans le rpertoire "envole", en principe vers le dossier "images" ou "ressources"
					}
				$query_string .= "&boxImg=".urlencode($boxImg);
				}
			if($detection_height==1)
				{
				$height_value = str_replace("px","",$matches_height[1]);
				$query_string .= "&boxHeight=".$height_value;
				}
			return $query_string;
			}
		}
	else return false;
	}

//ordre d'affichage du menu "outils" utilis par ajaxp_template.php
function setOutils()
	{
	global $ar_outils;
	$affichage = "";
	$ar_outils_torder = array
		(
		1=>"CDT",
		2=>"CALENDAR",
		3=>"WEBSHARE",
		4=>"MAIL",
		5=>"POST-IT",
		6=>"AIDE"
		);
	for($i=1;$i<=count($ar_outils_torder);$i++)
		{
		$outil = "OUTIL_".$ar_outils_torder[$i];
		if($i<=3) // outils facultatifs
			{
			$query_activate = mysql_query("SELECT `value` FROM `".PREFIX."ajaxp_settings` WHERE  `param`='APPLI_".$ar_outils_torder[$i]."'");
			$row_activate = mysql_fetch_assoc($query_activate);
			if(isset($row_activate["value"]) && $row_activate["value"]=="active" && array_key_exists($outil,$ar_outils)) $affichage .= $ar_outils[$outil];
			}
		else if(array_key_exists($outil,$ar_outils)) $affichage .= $ar_outils[$outil]; //outils obligatoires
		}
	return $affichage;
	}

function changePWD($action="afficher",$passwd_old,$passwd_new)
	{
	if($action=="valider")
		{
		$userid = $_SESSION['sess_userid'];
		
		if ( $passwd_old == '' || $passwd_new == '') return "Des champs sont rests vides. Opration abandonne.";
		else
			{
			include('libs/trace.php');
			include('libs/ldap.php');
			include('libs/mysql.php');
			include('libs/ldappasswd.php');
			include('connect_ldap.php');
			include("serverdata.php");
			
			$configSQL = array
				(
				'nomBase' => $dbName,
				'host' => $dbHost,
				'user' => $dbUser,
				'pass' => $dbPass
				);

			class sql extends Mysql
				{
				public function __construct(&$param)
					{
					parent::__construct($param);
					}
				public function __destruct()
					{
					parent::__destruct();
					}
				public function donneRNE()
					{
					parent::connect();
					$rne = parent::selectSimple("SELECT `value` FROM `".PREFIX."ajaxp_settings` WHERE `param`='RNE'");
					parent::deconnect();
					return $rne;
					}
				public function donneACADEMIE()
					{
					parent::connect();
					$acad = parent::selectSimple("SELECT `value` FROM `".PREFIX."ajaxp_settings` WHERE `param`='ACADEMIE'");
					parent::deconnect();
					return $acad;
					}
				}

			$connexion_sql = new sql($configSQL); 
			$rne = $connexion_sql->donneRNE();
			$academie = $connexion_sql->donneACADEMIE();
			$config = array
				(
				'host' => $ldap_server,
				'basedn' => 'ou='.$academie.',ou=education,o=gouv,c=fr',
				'branches' => array('ou=local,ou=personnels,ou=utilisateurs,ou='.$rne,'ou=local,ou=eleves,ou=utilisateurs,ou='.$rne,'ou=local,ou=responsables,ou=utilisateurs,ou='.$rne)
				);
			$connexion_ldap = new LDAP($config);
			//authenfication
			if ( $connexion_ldap->authentification($_SESSION['sess_username'],stripslashes($passwd_old)) )
				{
				//recupere le DN de l'utilisateur connecte
				$dnuser = $connexion_ldap->donneDN();
		
				//creation du chiffrage
				mt_srand( (double) microtime() * 1000000 );
				$salt = mhash_keygen_s2k( MHASH_SHA1, $passwd_new, substr( pack( "h*", md5( mt_rand() ) ), 0, 8 ), 4 );
				$new_value = "{SSHA}".base64_encode( mhash( MHASH_SHA1, $passwd_new.$salt ).$salt );
				
				//modification de son userPassword
				$modif['userPassword'] = $new_value;
				
				$passHash = new smbHash();
				
				//modification de son sambaLMPassword
				$modif['sambaLMPassword'] = $passHash->lmhash($passwd_new);
				
				//modification de son sambaNTPassword
				$modif['sambaNTPassword'] = $passHash->nthash($passwd_new);
							
				if ($connexion_ldap->modifierDonneesUtilisateur($dnuser,$modif,$_SESSION['sess_username'],stripslashes($passwd_old)))
					{
					//$dbConn = mysql_connect ($dbHost, $dbUser, $dbPass) or die ('MySQL connection failed. ' . mysql_error());
					//mysql_select_db($dbName) or die('Cannot select database. ' . mysql_error());
					//$query = "UPDATE  entajaxp_users SET password=PASSWORD(\"$passwd_new\") WHERE user_id=$userid";
		  			//mysql_query($query);
					return "ok";
					}
				else return "La modification de votre mot de passe a chou. Opration abandonne.";	
				}
			else return "L'authentification avec votre ancien mot de passe a chou. Opration abandonne.";
			}
		}
	elseif($action=="afficher")
		{
		$output = '
		<center>
		<form name="changepass" onsubmit="return changePWD(this)" method="post" action="">
		<h1>Modification de votre mot de passe</h1>
		<p style="color:#f00;">---- Attention, vous devrez ensuite vous reconnecter ----</p>
		<table class="table_form2">
		<col width="200px"><col width="200px">
		<tr>
		<th>Mot de passe actuel :</th>
		<td><input type="password" size="15" name="passwd_old" id="passwd_old" tabindex="1" /></td>
		</tr>
		<tr>
		<th>Nouveau mot de passe :</th>
		<td><input type="password" size="15"  name="passwd_new" id="passwd_new" tabindex="2" /></td>
		</tr>
		<tr>
		<th>Confirmation :</th>
		<td><input type="password" size="15" name="passwd_confirm" id="passwd_confirm" tabindex="3" /></td>
		</tr>
		</table>
		<br/><input type="submit" value="Changer" class="btn" tabindex="4" /><br/><br/>
		</form>
		</center>';
		}
	return $output;
	}

function findparam($arg,$champ="param")
	{
	switch($champ)
		{
		case "param" : //recherche d'un lment unique
		$donnee = mysql_query("SELECT `value` FROM `".PREFIX."ajaxp_settings` WHERE  `param`='".$arg."'");
		$ligne = mysql_fetch_assoc($donnee);
		return $ligne["value"];
		break;
		case "categorie": //recherche de tous les lments d'une catgorie
		$ar_categorie = array();
		$donnees = mysql_query("SELECT `param`,`value` FROM `".PREFIX."ajaxp_settings` WHERE  `categorie`='".$arg."'");
		while($ligne = mysql_fetch_assoc($donnees))
			{
			extract($ligne);
			$ar_categorie[$param]=$value;
			}
		return $ar_categorie;
		break;
		}
	}

function ajaxpWarnings()
	{
	if(!empty($_SESSION['warnings']))
		{
		echo '<script type="text/javascript" >fadeId("warnings");
		makeRequest("ajaxp_backend.php","?warnings");</script>';
		}
	}

function ajaxp_sendmail($to,$subject,$msg)
	{
	$headers = "MIME-Version: 1.0\n";
	$headers .= "Content-type: text/plain; charset=iso-8859-1\n";
	$headers .= "X-Priority: 3\n";
	$headers .= "X-MSMail-Priority: Normal\n";
	$headers .= "X-Mailer: PHP\n";
	$headers .= "From: \"Ajax Portal server\" <noreply@ajaxp.net>\n";
	$headers .= "Reply-To: noreply@ajaxp.net\n";
	if(mail($to,$subject,$msg,$headers)) {return TRUE;}
	}

//fonctions devenues inutile depuis la CASsification du portail (give_meta_id a t redfinie)
/*function eoleLogin($username,$password)
	{
	$username = security($username);
	$password = security($password);
	// Connexion au ldap
	$ldap_server="localhost";
	$ldap_port=389;
	// connexion ldap
	$ds=ldap_connect($ldap_server,$ldap_port) or die("Erreur de connexion  LDAP");
	// rcupration du dn
	$sr=ldap_search($ds,"o=gouv,c=fr","(uid=$username)");
	$info = ldap_get_entries($ds,$sr);
	// Si on ne trouve pas l'utilisateur on sort
	if ($info['count'] <=0 )
		{
		//echo "Erreur de login1";
		return false;
		}
	// On vrifie le couple utilisateur/motdepasse
	if ($password and (@ldap_bind($ds,$info[0]["dn"],$password)))
		{
		ldap_close($ds);
		// Si c'est ok
		// On regarde si Envole connait l'utilisateur
		$query = "SELECT * FROM  ".PREFIX."ajaxp_users WHERE username='$username';";
		$result = mysql_query($query);
		if(mysql_num_rows($result) > 0)
			{
			$query = "UPDATE  ".PREFIX."ajaxp_users SET password = PASSWORD(\"".$password."\") WHERE username='$username';"; 
			//echo "QUERY=$query<br/>".print_r($info);
			$result=mysql_query($query);
			$_SESSION['sess_statut'] = verif_statut_envole($username);
      		return true;
			}
		else
			{
			// Sinon on ajoute l'utilisateur  la base envole
			$md5 = md5($username);
			$statut=verif_statut_envole($username);
			switch ($statut)
				{
				case "eleve":
				$query = "INSERT INTO  ".PREFIX."ajaxp_users VALUES
						(NULL,\"".$username."\",\"".$info[0]['givenname'][0]."\",\"".$info[0]['sn'][0]."\",
						PASSWORD(\"".$password."\"),\"1\",NOW(),\"1\",\"".$info[0]['mail'][0]."\",
						0,\"s\",1,\"$md5\",'".give_meta_id("meta_eleve")."',\"-1\")"; 
				break;
				case "prof":
				$query = "INSERT INTO  ".PREFIX."ajaxp_users VALUES
						(NULL,\"".$username."\",\"".$info[0]['givenname'][0]."\",\"".$info[0]['sn'][0]."\",
						PASSWORD(\"".$password."\"),\"1\",NOW(),\"1\",\"".$info[0]['mail'][0]."\",
						0,\"s\",1,\"$md5\",'".give_meta_id("meta_prof")."',\"-1\")"; 
      			break;
				case "administrateur":
				$query = "INSERT INTO  ".PREFIX."ajaxp_users VALUES
						(NULL,\"".$username."\",\"".$info[0]['givenname'][0]."\",\"".$info[0]['sn'][0]."\",
						PASSWORD(\"".$password."\"),\"1\",NOW(),\"1\",\"".$info[0]['mail'][0]."\",
						0,\"s\",1,\"$md5\",'".give_meta_id("admin")."',\"-1\")"; 
				break;
				case "perdir":
				$query = "INSERT INTO  ".PREFIX."ajaxp_users VALUES
						(NULL,\"".$username."\",\"".$info[0]['givenname'][0]."\",\"".$info[0]['sn'][0]."\",
						PASSWORD(\"".$password."\"),\"1\",NOW(),\"1\",\"".$info[0]['mail'][0]."\",
						0,\"s\",1,\"$md5\",'".give_meta_id("meta_perdir")."',\"-1\")"; 
				break;
				}
			$result=mysql_query($query);
			if ($result)
				{
				switch ($statut)
					{
					case "eleve":
					inituserboxes($username,give_meta_id("meta_eleve"));
      				break;
					case "prof":
					inituserboxes($username,give_meta_id("meta_prof"));
					break;
					case "administrateur":
					inituserboxes($username,give_meta_id("admin"));
					break;
					case "perdir":
					inituserboxes($username,give_meta_id("meta_perdir"));
					break;
					}
				return true;
				}
			else {return false;}
			return true;
			}
		}
	else
		{
		//echo "Erreur de login2";
		ldap_close($ds);
		return false;
		}
	return false;
	}

function verif_statut_envole($login)
	{
	global $classe;
	$ldap_server="localhost";
	$ldap_port=389;
	// connexion ldap
	$ds=ldap_connect($ldap_server,$ldap_port) or die("Erreur de connexion LDAP");
	$sr=ldap_search($ds,"o=gouv,c=fr","(uid=$login)");
	$info = ldap_get_entries($ds,$sr);
	// Si on ne trouve pas l'utilisateur on sort
	if ($info['count']<=0)
		{
		echo "Erreur de login1";
		return false;
		}
	else
		{
		if ($info['count'] >1)
			{
			echo "Pr&eacute;sence de doublons";
			return false;
			}
		else
			{
			if (!isset($info[0]["typeadmin"][0]))
				{
				$classe=$info[0]["divcod"][0];
				$_SESSION['sess_classe'] =$classe;
				return "eleve";
				}
			if ((isset($info[0]["typeadmin"][0])) and (strtolower($login)<>"admin"))
				{
				return "prof";
				}			
			if (($info[0]["divcod"][0]=="autre") and (strtolower($login)=="admin"))
				{
				return "administrateur";
				}
			if (($info[0]["divcod"][0]=="autre") and (strtolower($login)<>"admin"))
				{
				return "perdir";
				}
			}
		}
	}

function give_meta_id($username)
	{
	$username = security($username);
	$query_id_meta="select user_id from entajaxp_users where username='$username'";
	$result_id_meta=mysql_query($query_id_meta) or die(mysql_error());
	if ($result_id_meta)
		{
		$row_id_el=mysql_fetch_row($result_id_meta);
		return $row_id_el[0];
		}
	else {return false;}
	}*/

//redfinie pour tre utilise en fonction du statut lors de l'enregistrement (et uniquement car ensuite le meta_id est lu en base) d'un nouvel utilisateur
function give_meta_id($statut)
	{
	switch ($statut)
		{
		case "National_1":
		case "eleve":
		$meta = "Meta_eleve";
		break;
		case "National_2":
		case "responsable":
		$meta = "Meta_parent";
		break;
		case "National_3":
		case "professeur":
		$meta = "Meta_prof";
		break;
		case "National_6":
		case "administratif":
		$meta = "Meta_perdir";
		break;
		case "administrateur":
		$meta = "admin";
		break;
		case "autre":
		default:
		$meta = "Visiteur";
		break;		
		}
	$query_id_meta="select user_id from entajaxp_users where username='".$meta."'";
	$result_id_meta=mysql_query($query_id_meta) or die(mysql_error());
	$row_id_el=mysql_fetch_row($result_id_meta);
	return $row_id_el[0];
	}
	
// donner l'accs  l'administrateur sur les requtes Mysql pour afficher et modifier l'environnement d'un mta
function give_user_id($userid)
	{
	if(isset($_SESSION['sess_logged_in']) && $_SESSION['sess_accesslevel']>10 && isset($_SESSION['sess_adm_env'])) return security($_SESSION['sess_adm_env'],3);
	else return security($userid,3);
	}




function sendPassword($email)
	{
	$email = security($email);
	$query = "SELECT * FROM  ".PREFIX."ajaxp_users WHERE email=\"$email\"";
	$result = mysql_query($query);
	if(mysql_num_rows($result) == 0) {return 0;}
	else
		{
		$row = mysql_fetch_array($result);
		$random_password = substr(md5(uniqid(microtime())), 0, 6);
		$query = "UPDATE  ".PREFIX."ajaxp_users SET password=PASSWORD(\"$random_password\") WHERE user_id=$row[user_id]";
		mysql_query($query);
		$msg = "$email,\n\nVous avez rclamer un nouveau mot de passe pour le portail EnvOLE dont vous tes utilisateur. Lorsque vous vous connecterez, changez votre mot de passe pour un que vous aurez choisi.\n\n";
		$msg .= "Identifiant: $row[username]\nMot de passe: $random_password\n\nConnexion ici: ".HTTP_URL.URI_PATH;
		if(ajaxp_sendmail($email,'Votre mot de passe EnvOLE',$msg)) {return 1;}
		}
	}

function showStyleSheets()
	{
	$query = "SELECT * FROM  ".PREFIX."ajaxp_themes";
	$result = mysql_query($query);
	$output= "";
	while ($row = mysql_fetch_assoc($result))
		{
		extract($row);
		$output .= '<link rel="alternate stylesheet" type="text/css" href="css/'.$row['css_name'].'" title="Style'.$row['theme_id'].'"/>';
		}
	echo $output;
	}

function isLoggedIn()
	{
	if(isset($_SESSION['sess_logged_in']) && (isset($_SESSION['sess_last_ip']) && $_SESSION['sess_last_ip'] == $_SERVER['REMOTE_ADDR']))
		{
		if(!isset($_SESSION['warnings'])) {$_SESSION['warnings']='Bienvenue '.$_SESSION["sess_username"].'!';}
		return 1;
		}
	else if(isset($_COOKIE["ajaxp_cookie"]))
		{
		$query = "SELECT * FROM  ".PREFIX."ajaxp_logins WHERE md5=\"".security($_COOKIE['ajaxp_cookie'])."\"";
		$result = mysql_query($query);
		$row = mysql_fetch_array($result);
		if( (time()-$row['date']) < (60*60*24*30) )
			{
			$query = "SELECT * FROM  ".PREFIX."ajaxp_users WHERE user_id=".$row['user_id']."";
			$result = mysql_query($query);
			$userinfo = mysql_fetch_assoc($result);
			if($userinfo['last_ip'] != $_SERVER['REMOTE_ADDR'])
				{
				setcookie("ajaxp_cookie"," ",time()-3600);
				return 0;
				}
			$_SESSION['sess_username'] = $userinfo['username'];
			$_SESSION['sess_rne'] =$rne;
			$_SESSION['sess_firstname'] = $userinfo['firstname'];
			$_SESSION['sess_lastname'] = $userinfo['lastname'];
			$_SESSION['sess_userid'] = $userinfo['user_id'];
			$_SESSION['sess_statut'] = verif_statut_envole($userinfo['username']);
			$_SESSION['sess_metaid'] = $userinfo['meta_id'];
			$_SESSION['sess_accesslevel'] = $userinfo['accesslevel'];
			$_SESSION['sess_usermd5'] = $userinfo['md5'];
			$_SESSION['sess_theme_id'] = $userinfo['theme_id'];
			$_SESSION['sess_last_ip'] = $_SERVER['REMOTE_ADDR'];
			$_SESSION['sess_logged_in'] = 1;
			if(!isset($_SESSION['warnings'])) {$_SESSION['warnings']='Bienvenue '.$_SESSION["sess_username"].'!';}
			return 1;
			}
		else
			{
			setcookie("ajaxp_cookie"," ",time()-3600);
			return 0;
			}
		}
	else {return 0;}
	}

function getUser($username)
	{
	$username = security($username,2);
	$sql = "SELECT user_id FROM  ".PREFIX."ajaxp_users WHERE username=\"$username\"";
	$result = mysql_query($sql);
	if(mysql_num_rows($result)>0)
	return 0;
	}

function buildBreadcrumb($page,$parent,$parentitem,$child,$childitem)
	{
	$childoutput='';
	$parentoutput ='';
	switch($child)
		{
		case 'all':
		$childoutput .=  $childitem;
		break;
		}
	switch($parent)
		{
		case 'all':
		$parentoutput .=  "<a href=\"#\" onclick=\"updateBox('all','$parentitem'); return false;\">$parentitem</a> &#187; ";
		break;
		}
	if (isset($output)) {return $output.$parentoutput.$childoutput;}
	else {return '';}
	}

function adpLookup($type,$itemid)
	{
	$version_envole=findparam('VERSION_PORTAIL');
	$error='';
	$output='';
	switch($type)
		{
		case 'password':
		$output .= '
		<div class="login">
		<form name="reminder" id="reminder" action="" onsubmit="return passwordADP(this)"  method="post">
		<div class="loginbox"><div id="header"><h1>Renvoi des mots de passe </h1> Un nouveau mot de passe va vous tre envoy.</div>
		<p>Votre adresse ml:<br/><input type="text" size="30" name="email" id="email" tabindex=3 value="" /><br/><br/></p>
		</div>
		<br/><input type="submit" value="Envoyer" class="btn" tabindex=7 /><br/>
		</form>
		<br/>
		Souvenez-vous en ? <a href="#"  onclick="switchPage(\'login\'); return false;"  title="Login ">Connexion</a>
		</div>';
		break;
		case 'register':
		$output='
		<form name="newuser" id="newuser" action="" onsubmit="return registerADP(this)"  method="post">
		<div class="loginbox">
		<div id="header"><h1>Abonnement au portail EnvOLE</h1>Merci de completer tous les champs...</div>
		<p id="error">'.$error.'</p>
		<p>
		Prnom:<br/><input type="text" size="20" name="register[firstname]" id="firstname" value="'.(isset($_POST['register']['firstname']) ? $_POST['register']['firstname'] : "").'" tabindex=1 /><br/>
		Nom:<br/><input type="text" size="20" name="register[lastname]" id="lastname" value="'.(isset($_POST['register']['lastname']) ? $_POST['register']['lastname'] : "").'" tabindex=2 /><br/>
		Addresse ml:<br/><input type="text" size="30" name="register[email]" id="email" tabindex=3 value="'.(isset($_POST['register']['email']) ? $_POST['register']['email'] : "").'" /><br/>
		Identifiant dsir:<br/><input type="text" size="15" name="register[new_username]" id="new_username" value="'.(isset($_POST['register']['username']) ? $_POST['register']['username'] : "").'" tabindex=4 /><br/>
		Mot de passe:<br/><input type="password" size="15" name="register[password]" id="password" tabindex=5 /><br/>
		Confirmer le mot de passe:<br/><input type="password" size="15" name="register[password2]" id="password2" tabindex=6 /><br/>
		</p>
		</div>
		<br/><input type="submit" value="S\'abonner!" class="btn" tabindex=7 /><br/>
		</form>
		Dj enregistr? <a href="#"  onclick="switchPage(\'login\'); return false;"  title="Login">Connexion</a>';
		break;
		case 'login':
		$output= '
		<div class="login">
		<form name="login"  onsubmit="return loginADP(this)"  action="" method="POST">
		<div class="loginbox"><div id="header"><h1>Connexion EnvOLE</h1></div>
		<p style="color:#0000FF; padding:10px; font-size:1.2em;">
		En attendant la mise &agrave; jour du serveur p&eacute;dagogique qui permettra de centraliser l&rsquo;authentification,<br/>il est fortement conseill&eacute; de <b>fermer le navigateur</b> apr&egrave;s vous &ecirc;tre d&eacute;connect&eacute; du Cartable En Ligne<br/>afin d&rsquo;assurer une d&eacute;connexion totale des diff&eacute;rentes applications utilis&eacute;es pendant la session.
		</p>
		<p>
		Identifiant  :<br/><input type="text" size="15" title="Entrez votre identifiant ici" name="username" tabindex="1" /><br/>
		Mot de passe :<br/><input type="password" size="15" title="Entrez votre mot de passe ici" name="password" tabindex="2" /><br/>
		<input type="hidden" name="remember" value="0"></input>
		</p>
		<br/>&nbsp;<input type="submit" value="Connexion" class="btn" tabindex="4" /><br/><br/>
		</form>
		</div>';
		break;
		case 'search':
		$output = "
		<form onsubmit='return searchBoxes(this); _tp(true);' method='get' action=''>\n
		<p>
		<strong>Search Keywords</strong><br/>
		<input type='text' onfocus='clearDefault(this)' name='searchbox' size='35'  value='[enter your search terms]' /><br/><br/>
		<strong>Where</strong><br/>
		<select name='search_options' size='1'>
		<option value='all'>All Fields</option>
		<option value='title'>Title</option>
		<option value='content'>Content</option>
		</select>
		<select  name='searchlocs' class='searchFrame'>
		<option value='0' selected>Whole site</option>
		<option value='1'>Current page</option>
		</select><br/><br/>
		<input type='submit' value='Submit Search' class='btn' />
		</p>\n
		</form>";
		break;
		case 'admin':
		unset($_SESSION['limit']);
		$query = "SELECT id,title, hidden, torder FROM  ".PREFIX."ajaxp_templates where user_id=".give_user_id($_SESSION['sess_userid'])." ORDER BY torder";
		$result = mysql_query($query);
		$output0='';
		$output .= "<p>\n";
		$output .= "<form onsubmit='editSettings(0,this); return false;' method='get' action=''>\n";
		$output .= "<h1>Pages disponibles:</h1>\n";
		$output0 .= "<select name='id'>\n";
		while ($row = mysql_fetch_assoc($result))
			{
			extract($row);
			$output0 .= "<option value=".$id." ".($torder == 1 ? "selected" : "").">".$title."</option>\n";
			$output .= $torder.". <strong>".$title."</strong> - ".($hidden == 0 ? "Visible" : "Cache")."<br />\n";
			}
		$output0 .= "</select><input type='submit' value='Go' class='btn' />\n";
		$output .= "<h1>Slectionnez une page  modifier:</h1>\n";
		$output .= $output0."</p></form>\n";
		$output .= "</p>\n";
		$output .= "<p>\n";
		$output .= "<h1>Gestion de ses informations personnelles</h1>\n";
		$output .= "<a href='#' onclick=\"changePWD(0); return false;\" title='Modifier son mot de passe'>Modifier son mot de passe</a><br/>\n";
		$output .= "</p>\n";
		if($_SESSION['sess_accesslevel']>1)
			{
			$output .= "<p>\n";
			$output .= "<h1>Gestion des utilisateurs</h1>\n";
			$output .= "<a href='#' onclick=\"adminEditUsers(0,'new'); return false;\" title='Habilitations'>Utilisateurs</a><br/>\n";
			$output .= "</p>\n";
			$output .= "<p>\n";
			$output .= "<h1>Menu 'ajouter du contenu'</h1>\n";
			$output .= "<a href='#' onclick=\"adminEditContenuMenu(0,'',''); return false;\" title='Edition du menu'>Edition du menu</a><br/>\n";
			$output .= "<a href='#' onclick=\"adminAddContenuMenu(0); return false;\" title='Ajout menu'>Ajout d'un contenu</a><br/>\n";
			$output .= "</p>\n";
			$output .= "<p>\n";$output .= "<h1>R-initialisation</h1>\n";
			$output .= "<a href='#' onclick=\"makeRequest('ajaxp_backend.php','?admreinitmaj');\" title='MAJ'>Mise  jour de l'environnement des utilisateurs du mta-modle</a><br/>\n";
			$output .= "<a href='#' onclick=\"makeRequest('ajaxp_backend.php','?admreinit');\" title='Reinit'>Reconstruction de l'environnement des utilisateurs du mta-modle</a><br/>\n";
			$output .= "<a href='#' onclick=\"makeRequest('ajaxp_backend.php','?admreord');\" title='Reord'>Remise en ordre de la numrotation des pages si elle est incorrecte</a><br/>\n";
			$output .= "</p>\n";
			// pour l'admin uniquement et seulement sous son propre environnement
			if ($_SESSION['sess_accesslevel']>10 && (!isset($_SESSION['sess_adm_env']) || $_SESSION['sess_adm_env']==22))
				{
				$output .= "<p>\n
				<h1>Accder et modifier l'environnement d'un mta-utilisateur</h1>\n";
				$query = "SELECT * FROM  ".PREFIX."ajaxp_users where accesslevel=10";
				$result = mysql_query($query);
				while($row = mysql_fetch_assoc($result))
				$output .= "<a href='#' onclick=\"makeRequest('ajaxp_backend.php','?adm_env=".$row['user_id']."');\" title='".$row['username']."'>".$row['username']."</a><br/>\n";
				$output .= "</p>\n";
				}
			}
		else
			{
			$output .= "<p>\n";
			$output .= "<h1>R-initialisation</h1>\n";
			$output .= "<a href='#' onclick=\"makeRequest('ajaxp_backend.php','?reinitmaj');\" title='MAJ'>Mise  jour de l'environnement  partir du modle dfini par l'administrateur</a><br/>\n";
			$output .= "<a href='#' onclick=\"makeRequest('ajaxp_backend.php','?reinit');\" title='Reinit'>Reconstruction de l'environnement  partir du modle dfini par l'administrateur</a><br/>\n";
			$output .= "</p>\n";
			}
		$output .= "<p>\n";
		$output .= "<h1>Thmes graphiques</h1>\n";
		$output .= "<a href='#' onclick=\"editUser('settings',0); return false;\" >Changer de thme</a><br/>\n";
		$output .= "</p>\n";
		break;
		case 'prefs':
		$query = "SELECT DATE_FORMAT(".PREFIX."ajaxp_users.date_created,'%M %D, %Y') as date_created FROM  ".PREFIX."ajaxp_users WHERE  ".PREFIX."ajaxp_users.user_id=".give_user_id($_SESSION['sess_userid']);
		$result = mysql_query($query);
		$row = mysql_fetch_array($result);
		$dayssince = (time()-strtotime($row['date_created'])) / (60 * 60 * 24);
		$output = "<div class=\"head\">";
		$output .= "<h2>Compte de $_SESSION[sess_firstname] $_SESSION[sess_lastname] ($_SESSION[sess_username])</h2></div>";
		$output .= "<p>\n";
		$output .= "<strong>"._Date_Joined_."</strong> $row[date_created]<br/><br/>\n";
		$output .= "<a href='#' onclick=\"editUser('info',0); return false;\" >Informations utilisateur</a><br/>";
		//$output .= "<a href='#' onclick=\"editUser('settings',0); return false;\" >Edit User Settings</a><br/>";
		$output .= "<a href='#' onclick=\"editUser('pass',0); return false;\" >Changement du mot de passe</a><br/><br/>";
		$output .= "</p>";
		break;
		case 'about':
		$output = "<div class=\"header\"><h1>EnvOLE (Environnement Ouvert Libre et Evolutif)</h1></div>";
		$output .= "<p>\n";
		$output .= "Projet libre et gratuit diffus&eacute; sous licence <acronym onclick=\"switchPage('licence'); _tp(true);\" title='Cea - Cnrs - Inria - Logiciels Libres'>CeCILL</acronym><br/>\n";
		$output .= "</p><p>Version $version_envole";
		$output .= "</p><p>Contact : ce.di@ac-creteil.fr";
		$output .= "</p>";
		break;
		case 'licence':
		if(file_exists('Licence_CeCILL_V2-fr.html')) $output = file_get_contents('Licence_CeCILL_V2-fr.html');
		else $output = "Le texte de la licence est introuvable.<br/>Voir sur le site : <a href='http://www.cecill.info'>www.cecill.info</a>";
		break;
		case 'stats':
		$result = mysql_query("SELECT COUNT(user_id) AS users FROM  ".PREFIX."ajaxp_users");
		$row = mysql_fetch_array($result);
		$result = mysql_query("SELECT COUNT(id) AS pages FROM  ".PREFIX."ajaxp_templates");
		$row1= mysql_fetch_array($result);
		$result = mysql_query("SELECT COUNT(id) AS pages FROM  ".PREFIX."ajaxp_templates where hidden=0");
		$row11= mysql_fetch_array($result);
		$result = mysql_query("SELECT COUNT(bid) AS boxes FROM  ".PREFIX."ajaxp_boxes");
		$row2= mysql_fetch_array($result);
		$output = "
		<div class=\"header\"><h1>Local Server Statistics</h1></div>
		<ul>
		<li>"._Registered_Users_."<strong> $row[users]</strong><br/>\n
		<li>"._Created_Pages_."<strong> $row1[pages]</strong> (visible  <strong>$row11[pages]</strong>)\n
		<li>"._Created_Boxes_."<strong> $row2[boxes]</strong>\n
		</ul>\n";
		break;
		case 'sharebox':
		if(isset($_SESSION['sess_logged_in']) && isset($_SESSION["sess_sharebox"]))
			{
			if(isset($_SESSION["sess_sharebox"]["boxImg"]))
				{
				$output .= "<h1>Que souhaitez-vous faire de l&rsquo;ic&ocirc;ne associ&eacute; &agrave; ce contenu ?</h1>\n";
				$output .= "<p><img src=\"".$_SESSION["sess_sharebox"]["boxImg"]."\"/></p>";
				$output .= "
				<form onsubmit=\"getImgSharebox(this); return false;\">\n
				<p style='margin:20px;'>\n
				<input type='radio' name='choixImg' value='1' checked='checked'/>Je souhaite acc&eacute;der &agrave; l&rsquo;image depuis son emplacement d&rsquo;origine.<br/>\n
				<input type='radio' name='choixImg' value='2'/>Je souhaite importer l&rsquo;image sur le serveur.
				</p>\n
				<p style='margin:20px;'>\n
				<input type='submit' value='Valider' class='btn' />\n&nbsp;
				<input type='button' value='Annuler l&rsquo;importation' class='redbtn' onclick=\"makeRequest('ajaxp_backend.php','?sharebox=stop'); return false;\" />\n
				</p>\n
				</form>\n";
				}
			else
				{
				$query = "SELECT `id`,`title`,`torder` FROM  `".PREFIX."ajaxp_templates` WHERE `user_id`=".give_user_id($_SESSION['sess_userid'])." ORDER BY torder";
				$result = mysql_query($query);
				$output .= "<h1>Choisir la page dans laquelle vous souhaitez ajouter le contenu \"".$_SESSION["sess_sharebox"]["boxTitle"]."\" :</h1>\n";
				$output .= "
				<form onsubmit=\"makeRequest('ajaxp_backend.php','?sharebox='+this.liste.options[this.liste.selectedIndex].value); return false;\">\n
				<p style='margin:20px;'>
				<select name='liste'>\n";
				while ($row = mysql_fetch_assoc($result))
					{
					extract($row);
					$output .= "<option value=".$id." ".($torder == 1 ? "selected" : "").">".$title."</option>\n";
					}
				$output .= "
				</select>\n
				</p>\n
				<p style='margin:20px;'>\n
				<input type='submit' value='Ajouter' class='btn' />\n&nbsp;
				<input type='button' value='Annuler' class='redbtn' onclick=\"makeRequest('ajaxp_backend.php','?sharebox=stop'); return false;\" />\n
				</p>\n
				</form>\n";
				if($_SESSION['sess_accesslevel']>1) //il s'agit d'un administrateur, une tape supplmentaire est ncessaire pour choisir la destination de la ressource
					{
					$output .= "
					<p style='margin:20px;'>
					<a href='#' onclick='adminAddContenuMenu(0);'>>>> En tant qu&rsquo;administrateur, cliquez ici si vous pr&eacute;f&eacute;rez mettre ce contenu dans le menu. <<<</a>
					</p>";
					}
				}
			}
		else
			{
			$output .= "
			<p>
			<h1>Probl&egraveme rencontr&eacute;</h1>
			Impossible de traiter l&rsquo;importation du contenu externe,<br/>soit vous n&rsquo;&ecric;tes pas connect&eacute;, soit les donn&eacute;es sont corrompues.
			</p>\n";
			}
		break;
		}
	return $output;
	}

function editSettings($update,$id,$title,$wpage,$dypage,$colw,$hidden,$torder,$oldtorder)
	{
	$id = security($id,3);
	$title = security($title);
	$wpage = security($wpage,3);
	$dypage = security($dypage,3);
	$colw = security($colw);
	$torder = security($torder,3);
	$hidden = security($hidden,3);
	$oldtorder = security($oldtorder,3);
	if($update)
		{
		// swap the torder of the new and old pages
		//mysql_query("UPDATE  ".PREFIX."ajaxp_templates SET torder=\"$oldtorder\" WHERE torder=$torder");
		// dcale les numros de page pour pouvoir y intercaler la nouvelle position demande
		$uid = give_user_id($_SESSION['sess_userid']);
		if($torder<$oldtorder) mysql_query("UPDATE  ".PREFIX."ajaxp_templates SET torder=torder+1 WHERE torder>=".$torder." AND torder<".$oldtorder." AND user_id=".$uid);
		if($torder>$oldtorder) mysql_query("UPDATE  ".PREFIX."ajaxp_templates SET torder=torder-1 WHERE torder<=".$torder." AND torder>".$oldtorder." AND user_id=".$uid);
		// chech whether this is not the last visible page
		$result = mysql_query("SELECT id FROM  ".PREFIX."ajaxp_templates WHERE hidden=0");
		$numofpages=mysql_num_rows($result);
		if($numofpages==1) { $hidden=0; $_SESSION['warnings']="cannot hide!<br>last visible"; }
		// update the new page settings
		mysql_query("UPDATE  ".PREFIX."ajaxp_templates SET title=\"$title\",wpage=\"$wpage\",dypage=\"$dypage\",maxic=\"$colw\",hidden=\"$hidden\",torder=\"$torder\" WHERE id=$id");
		// $_SESSION['page']=''; unset($_SESSION['page']);
		return 1;
		}
	$query = "SELECT id, title, wpage, dypage, maxic, hidden, torder,user_id FROM  ".PREFIX."ajaxp_templates WHERE id=$id";
	$result = mysql_query($query);
	$row = mysql_fetch_array($result);
	$uid=give_user_id($row['user_id']);
	$query = "SELECT id,torder FROM  ".PREFIX."ajaxp_templates where user_id=".$uid." ORDER BY torder";
	$result1= mysql_query($query);
	$temp=explode("~~|~~",$row['maxic']);$maxic=$temp[0];
	// if($maxic>count($temp)-1) { } else { $cunt=count($temp); }
	$cunt=count($temp);
	$output = "<div class=\"header\">\n";
	$output .= "<h1>"._Edit_Ajax_Portal_Template_." ".$row['title']."</h1></div>\n";
	$output .= "<form onsubmit='return editSettings(1,this)' method='get' action=''>\n";
	$output .= "<input type='hidden' name='oldtorder' value='".$row['torder']."' /><p>\n";
	$output .= "<table>\n";
	$output .= "<tr><td><strong>"._Page_Title_."</strong></td><td><strong>"._Page_Width_."</strong></td><td><strong>"._Cell_Spacing_."</strong></td><td><strong>"._N_of_Columns_."</strong></td><td><strong>Visibilit</strong></td><td><strong>Ordre</strong></td></tr>\n";
	$output .= '
	<tr>
	<td><input type="text" size="10" name="title" value="'.$row['title'].'" /></td>
	<td><input type="text" size="10" name="wpage" value="'.$row['wpage'].'" /></td>
	<td><input type="text" size="10" name="dypage" value="'.$row['dypage'].'" /></td>
	<td><input type="text" size="10" name="maxic" value="'.$maxic.'" /></td>
	<td>
	<select name="hidden">
	<option value="1" '.($row['hidden']==1 ? "selected" : "").' >Cache</option>
	<option value="0" '.($row['hidden']==0 ? "selected" : "").' >Visible</option>
	</select>
	</td> ';
	$output .= "<td><select name='torder'>\n";
	while ($row1 = mysql_fetch_assoc($result1))
		{
		$output.= "<option value=".$row1['torder']." ".($row1['torder'] == $row['torder'] ? "selected" : "").">".$row1['torder']."</option>\n";
		}
	$output .= "</select></td></tr>\n";
	$output .= "</table><br />\n";
	$output .= "<table border='0'><tr>\n";
	$output1= "<tr>\n"; $output2= "<tr>\n";
	$c=0;
	for($i=1; $i<$cunt; $i++)
		{
		$c++;
		$ccolwidth=str_replace("%","",$temp[$i]);
		if($ccolwidth==$temp[$i])
			{
			$sel1='';
			$sel2='selected';
			}
		else
			{
			$sel1='selected';
			$sel2='';
			}
		$output1 .= "<td><strong>"._Width_of_Col_." ".$i."</strong></td>\n";
		$output2 .= "
		<td>
		<input type='text' size='3' name='colw[]' value='".$ccolwidth."' />
		<select name='units[]'>\n
		<option value='%' ".$sel1.">%</option>
		<option value='' ".$sel2.">px</option>
		</select>
		&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
		</td>\n";
		if(($c-4)==0)
			{
			$output2 .= "</tr>\n";
			$output1 .= "</tr>".$output2."\n<tr>\n";
			$output2= "<tr>\n";
			$c=0;
			}
		}
	if($c!=0)
		{
		$output2 .= "</tr>\n";
		$output1 .= "</tr>\n";
		}
	$output  .= $output1.$output2;
	$output .= "</table><br />\n";
	$output .= "<input type='hidden' name='id' value='$id'/>\n";
	$output .= "
	<input type='submit' value='Sauvegarder' class='btn' />
	<input type='button' value='Annuler' onclick=\"switchPage('admin'); return false;\" class='redbtn' />\n";
	$output .= "</p></form>\n";
	$output .= _template_attention_."\n";
	$output .= _template_note_."\n";
	return $output;
	}

//****************************************
// JML filluser template from admin 
function adminituseridboxes($adminid)
	{
	$adminid = security($adminid,3);
	$query = "SELECT user_id FROM  ".PREFIX."ajaxp_users WHERE meta_id=".$adminid;
	$result = mysql_query($query);
	while($row = mysql_fetch_array($result))
		{
		$userid=$row['user_id'];
		inituseridboxes($userid,$adminid);
		}
	}

function admmajuseridboxes($adminid)
	{
	$adminid = security($adminid,3);
	$query = "SELECT user_id FROM  ".PREFIX."ajaxp_users WHERE meta_id=".$adminid;
	$result = mysql_query($query);
	while($row = mysql_fetch_array($result))
		{
		$userid=$row['user_id'];
		majuseridboxes($userid,$adminid);
		};
	}

function inituseridboxes($userid,$adminid)
	{
	$userid = security($userid,3);
	$adminid = security($adminid,3);
	// on supprime l'environnement de l'utilisateur
	$query_select_pages = "SELECT `id` FROM `".PREFIX."ajaxp_templates` WHERE `user_id`=".$userid.";";
	$result_select_pages = mysql_query($query_select_pages);
	while($row_select_page = mysql_fetch_assoc($result_select_pages))
		{
		$query_delete_boxes = "DELETE FROM `".PREFIX."ajaxp_boxes` WHERE `tid`=".security($row_select_page['id'],3).";";
		mysql_query($query_delete_boxes);
		}
	$query_delete_pages = "DELETE FROM `".PREFIX."ajaxp_templates` WHERE `user_id`=".$userid.";";
	mysql_query($query_delete_pages);
	
	// on rcupre le thme du mta
	$query_theme = "SELECT `theme_id` FROM `".PREFIX."ajaxp_users` WHERE `user_id`=".$adminid." LIMIT 1;";
	$result_theme = mysql_query($query_theme);
	if(mysql_num_rows($result_theme)>0)
		{
		$row_theme = mysql_fetch_assoc($result_theme);
		$theme_id = security($row_theme["theme_id"],3);
		$query_update_theme = "UPDATE `".PREFIX."ajaxp_users` SET `theme_id`=".$theme_id." WHERE `user_id`=".$userid.";";
		mysql_query($query_update_theme);
		// maj de la variable de session uniquement si la reconstruction est demande par un utilisateur
		if($_SESSION['sess_accesslevel']<10) $_SESSION['sess_theme_id'] = $theme_id;
		}
		
	// on recherche les pages du mta
	$query_select_pages = "SELECT * FROM `".PREFIX."ajaxp_templates` WHERE `user_id`=".$adminid.";";
	$result_select_pages = mysql_query($query_select_pages);
	while($row_select_page = mysql_fetch_assoc($result_select_pages))
		{
		// on cre une page pour l'utilisateur
		$title = security($row_select_page['title']);
		$wpage = security($row_select_page['wpage'],3);
		$dypage = security($row_select_page['dypage'],3);
		$maxic = security($row_select_page['maxic']);
		$hidden = security($row_select_page['hidden'],3);
		$torder = security($row_select_page['torder'],3);
		$id = security($row_select_page['id'],3);
		$query_insert_page = "INSERT INTO `".PREFIX."ajaxp_templates` 
		VALUES (NULL,'".$title."',".$wpage.",".$dypage.",'".$maxic."',".$hidden.",".$torder.",".$userid.",".$id.");";
		mysql_query($query_insert_page);
		$new_id = mysql_insert_id();
		
		// on cre toutes les botes appartenant  cette page
		$query_insert_boxes = "INSERT INTO `".PREFIX."ajaxp_boxes` 
		SELECT null,`seq`,".$new_id.",`title`,`content`,`cid`,`type`,`closable`,`bid` FROM `".PREFIX."ajaxp_boxes` WHERE `tid`=".$id.";";
		mysql_query($query_insert_boxes);
		}
	}

function majuseridboxes($userid,$adminid)
	{
	$userid = security($userid,3);
	$adminid = security($adminid,3);
	// connaitre le numro de la dernire page pour ajouter les nouvelles pages  la suite en adaptant la numrotation
	$query_page_max = "SELECT max(torder) FROM `".PREFIX."ajaxp_templates` WHERE `user_id`=".$userid.";";
	$result_page_max = mysql_query($query_page_max);
	$row_page_max = mysql_fetch_row($result_page_max);
	$page_max = $row_page_max[0];
	
	// on regarde chaque page du mta
	$ar_pages_ref = array();
	$query_select_pages = "SELECT * FROM `".PREFIX."ajaxp_templates` WHERE `user_id`=".$adminid." ORDER BY `torder`;";
	$result_select_pages = mysql_query($query_select_pages);
	while($row_select_page = mysql_fetch_assoc($result_select_pages))
		{
		$page_ref = security($row_select_page['id'],3);
		$ar_pages_ref[] = $page_ref;
		$query_search_page = "SELECT `id` FROM `".PREFIX."ajaxp_templates` WHERE `user_id`=".$userid." AND `ref_id`=".$page_ref." LIMIT 1;";
		$result_search_page = mysql_query($query_search_page);
		if(mysql_num_rows($result_search_page)>0) // l'utilisateur possde dj cette page, elle est mise  jour
			{
			$row_page = mysql_fetch_assoc($result_search_page);
			$page_id = security($row_page["id"],3);
			
			// on rcupre les botes de la page du mta
			$ar_boxes_ref = array();
			$query_meta_boxes = "SELECT * FROM `".PREFIX."ajaxp_boxes` WHERE `tid`=".$page_ref.";";
			$result_meta_boxes = mysql_query($query_meta_boxes);
			while($row_meta_box = mysql_fetch_assoc($result_meta_boxes))
				{
				$box_ref = security($row_meta_box['bid'],3);
				$ar_boxes_ref[] = $box_ref;
				$query_search_box ="SELECT `bid` FROM `".PREFIX."ajaxp_boxes` WHERE `tid`=".$page_id." AND `ref_id`=".$box_ref." LIMIT 1;";
				$result_search_box = mysql_query($query_search_box);
				if(mysql_num_rows($result_search_box)>0) // la bote existe dj, elle est mise  jour
					{
					$title_ref = security($row_meta_box['title']);
					$content_ref = $row_meta_box['content']; //non scuris car elle contient justement du code html qui doit tre interprt...
					$type_ref = security($row_meta_box['type']);
					$closable_ref = security($row_meta_box['closable'],3);
					$row_box = mysql_fetch_array($result_search_box);
					$box_id = security($row_box["bid"],3);
					$query_update_box = "UPDATE `".PREFIX."ajaxp_boxes` 
						SET `title`='".$title_ref."', `content`='".$content_ref."', `type`='".$type_ref."', `closable`=".$closable_ref." 
						WHERE `bid`=".$box_id." LIMIT 1;";
					mysql_query($query_update_box);
					}
				else // la bote n'existe pas, elle est cre
					{
					$query_insert_box = "INSERT INTO `".PREFIX."ajaxp_boxes` 
					SELECT null,`seq`,".$page_id.",`title`,`content`,`cid`,`type`,`closable`,".$box_ref." FROM `".PREFIX."ajaxp_boxes` WHERE `bid`=".$box_ref.";";
					mysql_query($query_insert_box);
					}
				}
			
			
			// on vrifie s'il n'y a pas de botes  supprimer
			$query_boxes_ref = "SELECT `bid`,`ref_id` FROM `".PREFIX."ajaxp_boxes` WHERE `tid`=".$page_id.";";
			$result_boxes_ref = mysql_query($query_boxes_ref);
			while($row_boxes_ref = mysql_fetch_assoc($result_boxes_ref))
				{
				$bid = security($row_boxes_ref['bid'],3);
				$ref_id = security($row_boxes_ref['ref_id'],3);
				if($ref_id>0 && !in_array($ref_id,$ar_boxes_ref))
					{
					$query_delete_box = "DELETE FROM `".PREFIX."ajaxp_boxes` WHERE `bid`=".$bid." LIMIT 1;";
					mysql_query($query_delete_box);
					}
				}
			}
		else // l'utilisateur ne possde pas cette page, elle est cre
			{
			$title = security($row_select_page['title']);
			$wpage = security($row_select_page['wpage'],3);
			$dypage = security($row_select_page['dypage'],3);
			$maxic = security($row_select_page['maxic']);
			$hidden = security($row_select_page['hidden'],3);
			$id = security($row_select_page['id'],3);
			$query_insert_page = "INSERT INTO `".PREFIX."ajaxp_templates` 
			VALUES (NULL,'".$title."',".$wpage.",".$dypage.",'".$maxic."',".$hidden.",".++$page_max.",".$userid.",".$id.")";
			mysql_query($query_insert_page);
			$new_id = mysql_insert_id();
			
			// on cre toutes les botes appartenant  cette page
			$query_insert_boxes = "INSERT INTO `".PREFIX."ajaxp_boxes` 
			SELECT null,`seq`,".$new_id.",`title`,`content`,`cid`,`type`,`closable`,`bid` FROM `".PREFIX."ajaxp_boxes` WHERE `tid`=".$id.";";
			mysql_query($query_insert_boxes);
			}
		}

	// on vrifie s'il n'y a pas de pages  supprimer
	$query_pages_ref = "SELECT `id`,`ref_id` FROM `".PREFIX."ajaxp_templates` WHERE `user_id`=".$userid.";";
	$result_pages_ref = mysql_query($query_pages_ref);
	while($row_pages_ref = mysql_fetch_assoc($result_pages_ref))
		{
		extract($row_pages_ref);
		if($ref_id>0 && !in_array($ref_id,$ar_pages_ref))
			{
			// on supprime les botes hrites du mta
			$query_delete_boxes = "DELETE FROM `".PREFIX."ajaxp_boxes` WHERE `tid`=".$id." AND `ref_id`>0;";
			mysql_query($query_delete_boxes);
			
			// on supprime la page si elle est vide
			$query_verify_boxes = "SELECT * FROM `".PREFIX."ajaxp_boxes` WHERE `tid`=".$id.";";
			$result_verify_boxes = mysql_query($query_verify_boxes);
			if(mysql_num_rows($result_verify_boxes)==0)
				{
				$query_delete_page = "DELETE FROM `".PREFIX."ajaxp_templates` WHERE `id`=".$id.";";
				mysql_query($query_delete_page);
				}
			}
		}
	}
	
function inituserboxes($username,$metaid)
	{
	$username = security($username,3);
	$metaid = security($metaid,3);
	// get user_id
	$sql = "SELECT user_id FROM  ".PREFIX."ajaxp_users WHERE username=\"$username\"";
	$result = mysql_query($sql);
	if(mysql_num_rows($result)>0)
		{
		$row = mysql_fetch_array($result);
		$userid=$row["user_id"];
		inituseridboxes($userid,$metaid);
		}
	} 

function adminAddUser($firstname='',$lastname='',$username='',$email='',$level='',$pass='',$metaid=0)
	{
	$firstname = security($firstname);
	$lastname = security($lastname);
	$username = security($username);
	$email = security($email);
	$level = security($level);
	$pass = security($pass);
	$metaid = security($metaid,3);
	if(!empty($firstname))
		{
		$md5 = md5($username);
		if(getUser($username)==1) { return 0; }
		$query = "INSERT INTO  ".PREFIX."ajaxp_users VALUES
				(NULL,\"".$username."\",\"".$firstname."\",\"".$lastname."\",
				PASSWORD(\"".$pass."\"),\"".$level."\",NOW(),1,\"".$email."\",0,\"s\",0,\"$md5\",".$metaid.",\"-1\")";
		if(mysql_query($query))
			{
			inituserboxes($username,$metaid);
			return 1;
			}
		}
	else
		{
		$output = "<div class=\"header\">";
		$output .= "<h1>Ajout d'un compte utilisateur</h1></div>";
		$output .= "<form onsubmit='return adminAddUser(this)' method='get' action=''>\n";
		$output .= "<p>\n";
		$output .= "<strong>Prnom</strong><br/><input type='text' size='20' name='firstname' id='firstname' tabindex='1' value='' /><br/>\n";
		$output .= "<strong>Nom</strong><br/><input type='text' size='20' name='lastname' id='lastname' tabindex='2' value='' /><br/>\n";
		$output .= "<strong>Identifiant dsir</strong><br/><input type='text' size='20' name='username' id='username' tabindex='3' value='' /><br/>\n";
		$output .= "<strong>Adresse ml</strong><br/><input type='text' size='30' name='email' id='email' tabindex='4' value='' /><br/><br/>\n";
		$output .= "<strong>Droits</strong><br/><select tabindex=5 name='perms'><option value='1'>Utilisateur (1)</option><option value='10'>Administrateur (10)</option></select><br/><br />\n";
		$output .= "<strong>mta-utilisateur</strong><br/><select tabindex='5' name='metaid'>";
		$query2 = "SELECT * FROM  ".PREFIX."ajaxp_users where accesslevel=10";
		$result2 = mysql_query($query2);
		while($row2 = mysql_fetch_array($result2))
			{
			$output .= "<option value='".$row2['user_id']."'  ".(give_user_id($_SESSION['sess_userid'])==$row2['user_id'] ? "selected" :"").">".$row2['username']."</option>";
			}
		$output .= "</select><br/><br/>\n";
		$output.="</ul>";
		$output .= "<strong>Mot de passe</strong><br/><input type='password' size='15' name='password' id='password' tabindex='6' value='' /><br/>\n";
		$output .= "<strong>Confirmation du mot de passe</strong><br/><input type='password' size='15' name='password2' id='password2' tabindex='7' value='' /><br/><br/>\n";
		$output .= "<input type='submit' value='Ajouter' class='btn' /> <input type='button' value='Cancel' onclick=\"switchPage('admin'); return false;\" class='redbtn' />\n";
		$output .= "</p></form>";
		return $output;
		}
	}

//****** avril 2008 : maj des fonctions adminAddContenuMenu() et adminEditContenuMenu() -> nouvelle ergonomie (voir ajaxp.css) et choix dynamique du type de contenu (voir ajaxp.js) 
//****** juillet 2008 : ajout d'une page spcifique pour les sites hbergs par l'acadmie (pages de l'intra)
function getImgRessources($dossier="")
	{
	$ar_extensions = array("jpg","bmp","png","gif","jpeg","tif","tiff");
	$output = "";
	if(is_dir($dossier))
		{
		$contenu = @scandir($dossier);
		if(is_array($contenu))
			{
			sort($contenu);
			foreach($contenu as $element)
				{
				if ($element == "." || $element == "..") continue;
				if(is_dir($dossier."/".$element)) $output .= getImgRessources($dossier."/".$element);
				$extension = strtolower(substr($element,strrpos($element,'.') + 1));
				if(is_file($dossier."/".$element) && in_array($extension,$ar_extensions))
				$output .= "
				<li 
				onmouseout=\"this.style.background='transparent';\" 
				onmouseover=\"this.style.background='#ccccff'; document.getElementById('img_ress').src=this.title;\" title='".$dossier."/".$element."' 
				onclick=\"document.getElementById('div_img_ress').style.display='none'; document.getElementById('icone').value=this.title;\"
				>
				".$element."</li>";
				}
			}
		}
	return $output;
	}

function getImgSharebox($choice="")
	{
	if(!isset($_SESSION["sess_sharebox"]["boxImg"])) return "aucune image &agrave; importer";
	$path = $_SESSION["sess_sharebox"]["boxImg"];
	unset($_SESSION["sess_sharebox"]["boxImg"]); //elle va tre inclus dans le "boxParam" et permet le passage  l'tape suivante dans adplookup
	switch($choice)
		{
		case "1" : //on conserve l'emplacement initial de l'image
		$_SESSION["sess_sharebox"]["boxParam"] .= "|".$path;
		return "succes1";
		break;
		
		case "2" : //on importe l'image dans "ressources/sharebox"
		$rep = "ressources/sharebox";
		if(!is_dir($rep) && !mkdir($rep)) return "impossible de cr&eacute;er le r&eacute;pertoire \"sharebox\"";
		if(preg_match("#/([^/]+)$#i",$path,$matches)===1) $filename = $matches[1]; //on rcupre le nom du fichier
		else return "fichier non identifi&eacute;";
		if(is_file($rep."/".$filename)) //le fichier existe dj
			{
			$_SESSION["sess_sharebox"]["boxParam"] .= "|".$rep."/".$filename;
			return "l&rsquo;image \"$filename\" existe d&eacute;j&agrave;";
			}
		$data = file_get_contents($path); //on rcupre le contenu de l'image
		if(!$data) return "echec lors de l&rsquo;upload";
		@$flux = @fopen($rep."/".$filename,"w"); //on cre l'image sur le serveur
		@fwrite($flux,$data);
		@fclose($flux);
		if(is_file($rep."/".$filename))
			{
			$_SESSION["sess_sharebox"]["boxParam"] .= "|".$rep."/".$filename;
			return "succes2";
			}
		else return "echec lors de la sauvegarde";
		break;
		
		default:
		return "choix non valide";
		break;
		}
	}

function adminAddContenuMenu($title='',$intra='',$type='',$param='',$icone='', $cat='',$boxheight=0,$torder=0,$closable=0,$metaid=0)
	{
	if(!empty($type))
		{
		if(preg_match("/^ressource_/i",$param)) $param = "redirection.php?ressource=".preg_replace("/^ressource_/i","",$param);
		if($intra=='oui') $param = "intra_redirection.php?url=".urlencode($param);
		if($icone=='') $query = "INSERT INTO  ".PREFIX."ajaxp_menu VALUES (NULL,\"".$title."\",\"".$type."\",\"".$param."\",".$boxheight.",".$torder.",".$closable.",".$metaid.",\"".$cat."\")";
		else $query = "INSERT INTO  ".PREFIX."ajaxp_menu VALUES (NULL,\"".$title."\",\"".$type."\",\"".$param."|".$icone."\",".$boxheight.",".$torder.",".$closable.",".$metaid.",\"".$cat."\")";
		if(mysql_query($query)) { return 1; }
		}
	else
		{
		if(isset($_SESSION["sess_sharebox"])) //cration d'un contenu  partir des donnes d'une ressource externe
			{
			$type = $_SESSION["sess_sharebox"]["newbox"];
			$title = $_SESSION["sess_sharebox"]["boxTitle"];
			$param = $_SESSION["sess_sharebox"]["boxParam"];
			if (strpos($_SESSION["sess_sharebox"]["boxParam"],'|')===false)
				{
				$params[0] = $_SESSION["sess_sharebox"]["boxParam"];
				$params[1] = '';
				}
			else $params = explode('|',$_SESSION["sess_sharebox"]["boxParam"]);
			if(isset($_SESSION["sess_sharebox"]["boxHeight"]) && intval($_SESSION["sess_sharebox"]["boxHeight"])>0) $boxheight = intval($_SESSION["sess_sharebox"]["boxHeight"]);
			unset($_SESSION["sess_sharebox"]);
			}
		else $params = array("",""); //nouveau contenu, tous les champs sont vides
		$query="select torder from ".PREFIX."ajaxp_menu ORDER by torder DESC limit 1";
		$result=mysql_query($query);
		$row = mysql_fetch_array($result);
		$torder=$row['torder']+1;
		$output = "
		<div id='div_img_ress'><img id='img_ress' src='#'/></div>
		<div class=\"header\">";
		$output .= "<h1>Ajout d'un contenu</h1></div>";
		$output .= "<form onsubmit='return adminAddContenuMenu(this)' method='get' action=''>\n";
		$output .= "
		<table class='table_form'><tr>
		<td></td>
		<td class='td_radio'><input type='radio' name='getcat' value='nonewcat' onClick='adminShowContenuMenu(this.value);' checked='checked'/></td>
		<td class='td_text'>Catgorie existante</td>
		<td class='td_radio'><input type='radio' name='getcat' value='newcat' onClick='adminShowContenuMenu(this.value);'/></td>
		<td class='td_text'>Nouvelle catgorie</td>
		<td></td>
		</tr></table>\n";
		$output .= "<table class='table_form'>\n";
		$output .= "
		<tr id=\"tr_cat\" style=\"display:none;\">
		<td class=\"tdl_form\">Catgorie :</td>
		<td class=\"tdr_form\"><input type='text' size='20' id='cat'  name='cat' value=\"\" /></td>
		</tr>\n";
		$output .= "
		<tr id=\"tr_list_cat\" style=\"display:block;\">
		<td class=\"tdl_form\">Catgorie :</td>
		<td class=\"tdr_form\"><select name='list_cat' id='list_cat'>";
		$query_cat = mysql_query("SELECT cat FROM ".PREFIX."ajaxp_menu WHERE meta_id=".give_user_id($_SESSION['sess_userid'])." OR meta_id=0 ORDER BY cat");
		$mem_cat ='';
		while($ligne = mysql_fetch_assoc($query_cat))
			{
			if ($ligne["cat"]!=$mem_cat)
				{
				// il faut reprer la catgorie "ZZAutres services" et enlever le "ZZ"
				$output .= "<option value=\"".$ligne["cat"]."\">".preg_replace("/^Z{2}/", "", $ligne["cat"])."</option>";
				$mem_cat = $ligne["cat"];
				}
			}
		$output .= "</select></td></tr>\n";
		$output .= "
		<tr id=\"tr_title\" style=\"display:block;\">
		<td class=\"tdl_form\">Titre :</td>
		<td class=\"tdr_form\"><input type='text' size='20' name='title' id='title' value=\"".$title."\" /></td>
		</tr>\n";
		$output .= "
		<tr id=\"tr_intra\" style=\"display:".($_SESSION['sess_intra_ip'] ? "block" : "none").";\">
		<td class=\"tdl_form\"><img src=\"images/nuvola/16x16/actions/kgpg.png\" alt=\"zone s&eacute;curis&eacute;e\" /></td>
		<td class=\"tdr_form\"><input type='checkbox' name='intra' id='intra'/>Contenu s&eacute;curis&eacute; h&eacute;berg&eacute; par l'acad&eacute;mie (Intra)</td>
		</tr>\n";
		$output .= "
		<tr id=\"tr_cbox_ress\" style=\"display:".(findparam('ACADEMIE')=="ac-creteil" ? "block" : "none").";\">
		<td class=\"tdl_form\"></td>
		<td class=\"tdr_form\"><input type='checkbox' name='cbox_ress' id='cbox_ress' onchange='adminShowContenuMenu(this.form.type.value);'/>Ressource pr&eacute;d&eacute;finie</td>
		</tr>\n";
		$output .= "
		<tr id=\"tr_type\" style=\"display:block;\">
		<td class=\"tdl_form\">Type :</td>
		<td class=\"tdr_form\"><select name='type' id='type' style='background:#fcc;' onChange='adminShowContenuMenu(this.value);'>";
		if(empty($type)) $output .= "<option value='choiceBox' selected='selected'>Veuillez s&eacute;lectionner un type de contenu</option>";
		$output .= "
		<option value='htmlBox' ".($type == 'htmlBox' ? "selected" : "").">Page HTML ouverte automatiquement dans un portlet</option>
		<option value='inBox' ".($type == 'inBox' ? "selected" : "").">Lien vers une page HTML interne  l'environnement</option>
		<option value='outBox' ".($type == 'outBox' ? "selected" : "").">Lien vers une page HTML externe  l'environnement</option>
		<option value='newsBox' ".($type == 'newsBox' ? "selected" : "").">News RSS (newsBox)</option>
		<option value='noteBox' ".($type == 'noteBox' ? "selected" : "").">Web-note (Bloc note web)</option>
		</select></td>
		</tr>\n";
		$output .= "
		<tr id=\"tr_param\" style=\"display:none;\">
		<td class=\"tdl_form\">Adresse du contenu :</td>
		<td class=\"tdr_form\"><input type='text' size='50' id='param'  name='param' value=\"".$params[0]."\" /></td>
		</tr>\n";
		//liste des ressources disponibles
		$output .= "
		<tr id=\"tr_liste_ress\" style=\"display:none;\">
		<td class=\"tdl_form\">Choisir une ressource :</td>
		<td class=\"tdr_form\">
		<select name='liste_ress' id='liste_ress'>";
		$query = "SELECT `param`,`affichage`,`categorie` FROM  `".PREFIX."ajaxp_settings` WHERE `categorie` LIKE 'Ressources%abonnement' ORDER BY `categorie`,`affichage`;";
		$result = mysql_query($query);
		$optgroupe = "";
		while($row=mysql_fetch_assoc($result))
			{
			extract($row);
			if($optgroupe!=$categorie)
				{
				if($optgroupe!="") $output .= "</optgroup>";
				$optgroupe=$categorie;
				$output .= "<optgroup label=\"".$optgroupe."\">";
				}
			$output .= "<option value=\"".strtolower($param)."\">".$affichage."</option>";
			}
		$output .= "</optgroup></select></td></tr>";
		$output .= "
		<tr id=\"tr_icone\" style=\"display:none;\">
		<td class=\"tdl_form\">Adresse de l'icne (facultative) :</td>
		<td class=\"tdr_form\"><input type='text' size='50' id='icone' name='icone' value=\"".$params[1]."\" /></td>
		</tr>\n";
		$output .= "
		<tr id=\"tr_img_cel\" style=\"display:none;\">
		<td class=\"tdl_form\">ou</td>
		<td class=\"tdr_form\">
		<div onclick=\"document.getElementById('ul_ress').style.display = (document.getElementById('ul_ress').style.display=='block') ? 'none' : 'block';\">
		<div id=\"div_title_ress\">>>> Liste des images disponibles <<<</div>
		<ul 
		id=\"ul_ress\" 
		onmouseover=\"document.getElementById('div_img_ress').style.display='block';\" 
		onmouseout=\"document.getElementById('div_img_ress').style.display='none';\"
		>";
		$output .= "<li class=\"optgroup\">Dossier Ressources :</li>";
		$output .= getImgRessources("../ressources");
		$output .= "<li class=\"optgroup\">Dossier Images :</li>";
		$output .= getImgRessources("images");
		$output .= "</ul></div></td></tr>\n";
		$output .= "
		<tr id=\"tr_boxheight\" style=\"display:none;\">
		<td class=\"tdl_form\">Hauteur du cadre :<br/>(0=hauteur par dfaut)</td>
		<td class=\"tdr_form\"><input type='text' size='20' id='boxheight' name='boxheight' value='".$boxheight."' /></td>
		</tr>\n";
		$output .= "
		<tr id=\"tr_closable\" style=\"display:none;\">
		<td class=\"tdl_form\">Fermeture du cadre si h&eacute;rit&eacute; du M&eacute;ta :</td>
		<td class=\"tdr_form\"><select name='closable' id='closable'>
		<option value='0' 'selected' >autorise</option>
		<option value='1'>interdite</option>
		</select></td>
		</tr>\n";
		$output .= "
		<tr id=\"tr_metaid\" style=\"display:none;\">
		<td class=\"tdl_form\">Visibilit :</td>
		<td class=\"tdr_form\"><select name='metaid'>
		<option value='".give_user_id($_SESSION['sess_userid'])."' selected>pour les utilisateurs du modle seulement</option>
		<option value='0' >pour tous</option>
		</select></td>
		</tr></table><br/>\n";
		//$output .= "<strong>Ordre dans le menu</strong><br/><input type='text' size='20' name='torder' id='torder' value=\"".$torder."\" /><br/><br/>\n";
		$output .= "<input type='hidden' size='20' name='torder' id='torder' value=\"".$torder."\" />\n";
		$output .= "
		<input type='submit' value='Ajouter' class='btn' />&nbsp;
		<input type='button' value='Annuler' onclick=\"switchPage('admin'); return false;\" class='redbtn' />\n";
		$output .= "</form>";
		if(!empty($type)) $output .= "::|::adminShowContenuMenu('".$type."');";
		return $output;
		}
	}

function adminEditUsers($userid=0,$action='',$active='',$perms='',$metaid=0,$charte='-1')
	{
	$userid = security($userid,3);
	if($userid!=0)
		{
		if($action == 'user')
			{
			$query = "SELECT * FROM  ".PREFIX."ajaxp_users WHERE user_id=$userid";
			$result = mysql_query($query);
			$row = mysql_fetch_array($result);
			$output = "<div class=\"header\">";
			$output .= "<h1>Modifier l'utilisateur - $row[username]</h1></div>";
			$output .= "<form onsubmit=\"return adminEditUsers($userid,'mod',this)\" method='get' action=''>\n";
			$output .= "<p>\n";
			$output .= "<strong>Statut</strong><br/>
			<select name='active'>
			<option value='1' ".($row['active'] == '1' ? "selected" : "").">Actif</option>
			<option value='0' ".($row['active'] == '0' ? "selected" : "").">Suspendu</option>
			</select><br/><br/>\n";
			$output .= "<strong>Droits</strong><br/>
			<select name='perms'><option value='1' ".($row['accesslevel'] == '1' ? "selected" : "").">Utilisateur (1)</option>
			<option value='10' ".($row['accesslevel'] == '10' ? "selected" : "").">M&eacute;ta-utilisateur (10)</option>
			</select><br/><br/>\n";
			$output .= "<strong>M&eacute;ta-mod&egrave;le</strong><br/>
			<select tabindex=5 name='metaid'>";
			$query2 = "SELECT * FROM  ".PREFIX."ajaxp_users where accesslevel>1";
			$result2 = mysql_query($query2);
			while($row2 = mysql_fetch_array($result2))
				{
				$output .= "<option value='".$row2['user_id']."' ".($row['meta_id'] == $row2['user_id'] ? "selected" : "").">".$row2['username']."</option>";
				}
			$output .= "</select><br/><br/>\n";
			if(isset($_SESSION['charte']) && $_SESSION['charte']=="ok")
				{
				$output .= "<strong>Charte du cartable</strong><br/>
				<select name='charte'>
				<option value='-1' ".($row['charte'] != '0' ? "selected" : "").">Non Valide</option><option value='0' ".($row['charte'] == '0' ? "selected" : "").">Valide</option>
				</select><br/><br/>\n";
				}
			else $output .="<input type='hidden' name='charte' value='".$row['charte']."'/>";
			$output .= "
			<input type='submit' value='Valider' class='btn' />&nbsp;
			<input type='button' value='Annuler' onclick=\"adminEditUsers(0,'new',''); return false;\" class='redbtn' />\n";
			$output .= "</p></form>";
			}
		elseif($action=='mod')
			{
			$active = security($active,3);
			$perms = security($perms,3);
			$metaid = security($metaid,3);
			$charte = security($charte);
			$query = "UPDATE  ".PREFIX."ajaxp_users SET active=$active, accesslevel=$perms, meta_id=$metaid, charte=$charte WHERE user_id=$userid";
			$result = mysql_query($query);
			inituseridboxes($userid,$metaid);
			return 2;
			}
		elseif($action=='del')
			{
			$query = "DELETE FROM  ".PREFIX."ajaxp_users WHERE user_id=$userid";
			$result = mysql_query($query);
			return 1;
			}
		}
	else
		{
		if($action=='new') $_SESSION['limit']=0;
		$i_limit= (int)$_SESSION['limit'];
		$_SESSION['limit'] = $i_limit+30;
		$output = "<h1>Gestion des comptes utilisateurs";
		if(isset($_SESSION['charte']) && $_SESSION['charte']=="ok")
			{
			$output .= "<br/>
			<img src='images/nuvola/8x8/actions/ledgreen.png' alt='Charte Valid&eacute;e'/> Charte Valid&eacute;e&nbsp;&nbsp;&nbsp;&nbsp;
			<img src='images/nuvola/8x8/actions/ledred.png' alt='Charte non Valid&eacute;e'/> Charte non Valid&eacute;e";
			}
		$output .= "</h1>";
		$query_count="select count(*) FROM  ".PREFIX."ajaxp_users";
		$result_count = mysql_query($query_count);
		$num=mysql_fetch_row($result_count);
		$userid = give_user_id($_SESSION['sess_userid']);
		$query = "SELECT * FROM  ".PREFIX."ajaxp_users WHERE user_id!=".$userid." and meta_id=".$userid." order by lastname asc limit $i_limit , 30 ;";
		$result = mysql_query($query);
		$output .= "<div class=\"head\" style=\"overflow: auto;\">";
		$output .= "
		<div class=\"right\">
		<a href=\"#\" onclick=\"switchPage('admin'); return false;\" title=\"Retour au menu prcdent\">Retour au menu prcdent</a>
		</div>";
		if ($num[0]>$_SESSION['limit'])
			{
			$output .= "
			<div class=\"left\">
			<a href=\"#\" onclick=\"adminEditUsers(0,'',''); return false;\" title=\"Suite de la liste\">Suite de la liste</a>
			</div>";
			}
		$output .= "</div><table style='text-align:left; margin:0px auto;'>";
		$count=1;
		while($row = mysql_fetch_array($result))
			{
			($count%2 == 0 ? $alt = "class=\"alt\"" : $alt = '');
			$output .= "<tr>";
			if(isset($_SESSION['charte']) && $_SESSION['charte']=="ok")
				{
				if ($row['charte']==0) $output .= "<td><img src='images/nuvola/8x8/actions/ledgreen.png' alt='Charte Valid&eacute;e' /></td>";
				else  $output .= "<td><img src='images/nuvola/8x8/actions/ledred.png' alt='Charte non Valid&eacute;e' /></td>";
				}
			$output .= "
			<td $alt>
			<span class='user'> - $row[lastname] $row[firstname] - ( <strong>$row[username]</strong> ) </span>&nbsp;
			<span class='links'><a href='#' title='Modifier' onclick=\"adminEditUsers($row[user_id],'user'); return false;\" >Modifier</a></span>
			</td></tr>";
			$count++;
			}
		$output .= "</table>";
		}
	return $output;
	}

//$debugstring="";

function adminEditContenuMenu($menuid=0,$action='',$title='',$intra='',$type='',$param='',$icone='',$cat='',$boxheight=0,$torder=0,$closable=0,$metaid=0)
	{
	$menuid = security($menuid,3);
	if($menuid!=0)
		{
		if($action == 'menu')
			{
			$query = "SELECT * FROM  ".PREFIX."ajaxp_menu where id=".$menuid;
			$result = mysql_query($query);
			$row = mysql_fetch_array($result);
			//dcomposition de l'url : vrifier la prsence de intra_redirection.php + sparer adresse et icne si cette dernire est spcifie
			if(preg_match("/^intra_redirection.php\?url=/",$row['param']))
				{
				$checked_intra="checked=\"checked\"";
				$url = urldecode(preg_replace("/^intra_redirection.php\?url=/","",$row['param']));
				}
			else
				{
				$checked_intra="";
				$url = $row['param'];
				}
			if (strpos($url,'|')===false)
				{
				$params[0] = $url;
				$params[1] = '';
				}
			else $params = explode('|', $url);
			$output = "
			<div id='div_img_ress'><img id='img_ress' src='#'/></div>
			<div class=\"header\">";
			$output .= "<h1>Option de menu - ".$row['title']."</h1></div>";
			$output .= "<form onsubmit=\"return adminEditContenuMenu(".$menuid.",'mod',this)\" method='get' action=''>\n";
			$output .= "
			<table class='table_form'><tr>
			<td></td>
			<td class='td_radio'><input type='radio' name='getcat' value='nonewcat' onClick='adminShowContenuMenu(this.value);' checked='checked'/></td>
			<td class='td_text'>Catgorie existante</td>
			<td class='td_radio'><input type='radio' name='getcat' value='newcat' onClick='adminShowContenuMenu(this.value);'/></td>
			<td class='td_text'>Nouvelle catgorie</td><td></td>
			</tr></table>\n";
			$output .= "<table id='table_form'>\n";
			$output .= "
			<tr id=\"tr_cat\" style=\"display:none;\">
			<td class=\"tdl_form\">Catgorie :</td>
			<td class=\"tdr_form\"><input type='text' size='20' id='cat'  name='cat' value=\"".preg_replace("/^Z{2}/", "", $row["cat"])."\" /></td>
			</tr>\n";
			$output .= "
			<tr id=\"tr_list_cat\" style=\"display:block;\">
			<td class=\"tdl_form\">Catgorie :</td>
			<td class=\"tdr_form\">
			<select name='list_cat' id='list_cat'>";
			$query_cat = mysql_query("SELECT cat FROM ".PREFIX."ajaxp_menu WHERE meta_id=".give_user_id($_SESSION['sess_userid'])." OR meta_id=0 ORDER BY cat");
			$mem_cat ='';
			while($ligne = mysql_fetch_assoc($query_cat))
				{
				if ($ligne["cat"]!=$mem_cat)
					{
					// il faut reprer la catgorie "ZZAutres services" et enlever le "ZZ"
					$output .= "<option value=\"".$ligne["cat"]."\" ".($ligne["cat"] == $row['cat'] ? "selected" : "").">".preg_replace("/^Z{2}/", "", $ligne["cat"])."</option>";
					$mem_cat = $ligne["cat"];
					}
				}
			$output .= "</select></td></tr>\n";
			$output .= "
			<tr id=\"tr_title\" style=\"display:block;\">
			<td class=\"tdl_form\">Titre :</td>
			<td class=\"tdr_form\"><input type='text' size='20' name='title'id='title' value=\"".$row['title']."\" /></td>
			</tr>\n";
			$output .= "
			<tr id=\"tr_intra\" style=\"display:".($_SESSION['sess_intra_ip'] ? "block" : "none").";\">
			<td class=\"tdl_form\"><img src=\"images/nuvola/16x16/actions/kgpg.png\" alt=\"zone s&eacute;curis&eacute;e\" /></td>
			<td class=\"tdr_form\"><input type='checkbox' name='intra' id='intra' ".($_SESSION['sess_intra_ip'] ? $checked_intra : "")."/>Contenu s&eacute;curis&eacute; h&eacute;berg&eacute; par l'acad&eacute;mie (Intra)</td>
			</tr>\n";
			if(preg_match("/redirection.php\?ressource=([^&]*)/",$params[0],$param_ress)) $ressource_checked = "checked='checked'";
			else $ressource_checked = "";
			$output .= "
			<tr id=\"tr_ressources\" style=\"display:".(findparam('ACADEMIE')=="ac-creteil" ? "block" : "none").";\">
			<td class=\"tdl_form\"></td>
			<td class=\"tdr_form\"><input type='checkbox' name='cbox_ress' id='cbox_ress' onchange='adminShowContenuMenu(this.form.type.value);' ".$ressource_checked."/>Ressource pr&eacute;d&eacute;finie</td>
			</tr>\n";
			$output .= "
			<tr id=\"tr_type\" style=\"display:block;\">
			<td class=\"tdl_form\">Type :</td>
			<td class=\"tdr_form\">
			<select name='type' id='type' onChange='adminShowContenuMenu(this.value);'>
			<option value='htmlBox' ".($row['type'] == 'htmlBox' ? "selected" : "").">Page HTML ouverte automatiquement dans un portlet</option>
			<option value='inBox' ".($row['type'] == 'inBox' ? "selected" : "").">Lien vers une page HTML interne  l'environnement</option>
			<option value='outBox' ".($row['type'] == 'outBox' ? "selected" : "").">Lien vers une page HTML externe  l'environnement</option>
			<option value='newsBox' ".($row['type'] == 'newsBox' ? "selected" : "").">News RSS (newsBox)</option>
			<option value='noteBox' ".($row['type'] == 'noteBox' ? "selected" : "").">Web-note (Bloc note web)</option>
			</select>
			</td>
			</tr>\n";
			$output .= "
			<tr id=\"tr_param\" style=\"display:none;\">
			<td class=\"tdl_form\">Adresse du contenu :</td>
			<td class=\"tdr_form\"><input type='text' size='50' id='param'  name='param' value=\"".$params[0]."\" /></td>
			</tr>\n";
			//liste des ressources disponibles
			$output .= "
			<tr id=\"tr_liste_ress\" style=\"display:none;\">
			<td class=\"tdl_form\">Choisir une ressource :</td>
			<td class=\"tdr_form\">
			<select name='liste_ress' id='liste_ress'>";
			$query_ress = "SELECT `param`,`affichage`,`categorie` FROM  `".PREFIX."ajaxp_settings` WHERE `categorie` LIKE 'Ressources%abonnement' ORDER BY `categorie`,`affichage`;";
			$result_ress = mysql_query($query_ress);
			$optgroupe = "";
			while($row_ress=mysql_fetch_assoc($result_ress))
				{
				extract($row_ress);
				if($optgroupe!=$categorie)
					{
					if($optgroupe!="") $output .= "</optgroup>";
					$optgroupe=$categorie;
					$output .= "<optgroup label=\"".$optgroupe."\">";
					}
				$param = strtolower($param);
				$output .= "<option value=\"".$param."\" ".(!empty($ressource_checked) && $param=="ressource_".$param_ress[1] ? "selected=\"selected\"" : "").">".$affichage."</option>";
				}
			$output .= "</optgroup></select></td></tr>";
			$output .= "
			<tr id=\"tr_icone\" style=\"display:none;\">
			<td class=\"tdl_form\">Adresse de l'icne (facultative) :</td>
			<td class=\"tdr_form\"><input type='text' size='50' id='icone'  name='icone' value=\"".$params[1]."\" /></td>
			</tr>\n";
			$output .= "
			<tr id=\"tr_img_cel\" style=\"display:none;\">
			<td class=\"tdl_form\">ou</td>
			<td class=\"tdr_form\">
			<div onclick=\"document.getElementById('ul_ress').style.display = (document.getElementById('ul_ress').style.display=='block') ? 'none' : 'block';\">
			<div id=\"div_title_ress\">>>> Liste des images disponibles <<<</div>
			<ul 
			id=\"ul_ress\" 
			onmouseover=\"document.getElementById('div_img_ress').style.display='block';\" 
			onmouseout=\"document.getElementById('div_img_ress').style.display='none';\"
			>";
			$output .= "<li class=\"optgroup\">Dossier Ressources :</li>";
			$output .= getImgRessources("../ressources");
			$output .= "<li class=\"optgroup\">Dossier Images :</li>";
			$output .= getImgRessources("images");
			$output .= "</ul></div></td></tr>\n";
			$output .= "
			<tr id=\"tr_boxheight\" style=\"display:none;\">
			<td class=\"tdl_form\">Hauteur du cadre :<br/>(0=hauteur par dfaut)</td>
			<td class=\"tdr_form\"><input type='text' size='20' id='boxheight' name='boxheight' value=\"".$row['boxheight']."\" /></td>
			</tr>\n";
			$output .= "
			<tr id=\"tr_closable\" style=\"display:block;\">
			<td class=\"tdl_form\">Fermeture du cadre si h&eacute;rit&eacute; du M&eacute;ta :</td>
			<td class=\"tdr_form\">
			<select name='closable' id='closable'>
			<option value='0' ".($row['closable'] == 0 ? "selected" : "").">autorise</option>
			<option value='1' ".($row['closable'] == 1 ? "selected" : "").">interdite</option>
			</select>
			</td>
			</tr>\n";
			$userid = give_user_id($_SESSION['sess_userid']);
			$output .= "
			<tr id=\"tr_metaid\" style=\"display:block;\">
			<td class=\"tdl_form\">Visibilit :</td>
			<td class=\"tdr_form\">
			<select name='metaid'>
			<option value='".$userid."' ".($row['meta_id'] == $userid ? "selected" : "").">pour les utilisateurs du modle seulement</option>
			<option value='0' ".($row['meta_id'] == 0 ? "selected" : "").">pour tous</option>
			</select>
			</td>
			</tr>
			</table><br/>\n";
			//$output .= "<strong>Ordre dans le menu</strong><br/><input type='text' size='20' name='torder' id='torder' value=\"".$torder."\" /><br/><br/>\n";
			$output .= "<input type='hidden' size='20' name='torder' id='torder' value=\"".$row['torder']."\" />\n";
			$output .= "
			<input type='submit' value='Valider' class='btn' />&nbsp;
			<input type='button' value='Annuler' onclick=\"adminEditContenuMenu(0); return false;\" class='redbtn' />\n";
			$output .= "</form>::|::adminShowContenuMenu('".$row['type']."');";
			}
		elseif($action=='mod')
			{
			$title = security($title);
			$intra = security($intra);
			$type = security($type);
			$param = security($param);
			$icone = security($icone);
			$cat = security($cat);
			$boxheight = security($boxheight,3);
			$torder = security($torder,3);
			$closable = security($closable,3);
			$metaid = security($metaid,3);
			if(preg_match("/^ressource_/i",$param)) $param = "redirection.php?ressource=".preg_replace("/^ressource_/i","",$param);
			if($intra=='oui') $param = "intra_redirection.php?url=".urlencode($param);
			if($icone=='') $query = "UPDATE  ".PREFIX."ajaxp_menu SET title=\"".$title."\",type=\"".$type."\",param=\"".$param."\",cat=\"".$cat."\",boxheight=".$boxheight.",torder=".$torder.",closable=".$closable.",meta_id=".$metaid." WHERE id=".$menuid; 
			else $query = "UPDATE  ".PREFIX."ajaxp_menu SET title=\"".$title."\",type=\"".$type."\",param=\"".$param."|".$icone."\",cat=\"".$cat."\",boxheight=".$boxheight.",torder=".$torder.",closable=".$closable.",meta_id=".$metaid." WHERE id=".$menuid;
			//$debugstring=$query;
			$result = mysql_query($query);
			return 2;
			}
		elseif($action=='del')
			{
			$query = "DELETE FROM  ".PREFIX."ajaxp_menu WHERE id=".$menuid;
			$result = mysql_query($query);
			return 1;
			}
		}
	else
		{
		$output = "<div class=\"head\">";
		$output .= "
		<div class=\"right\">
		<a href=\"#\" onclick=\"switchPage('admin'); return false;\" title=\"Retour au menu prcdent\">Retour au menu prcdent</a>
		</div>";
		$output .= "<br /><h2>Edition du menu 'ajouter du contenu'</h2>";
		//$output.=$debugstring;
		$query = "SELECT * FROM  ".PREFIX."ajaxp_menu  where meta_id=".give_user_id($_SESSION['sess_userid'])." or meta_id=0 ORDER BY cat,title";
		$result = mysql_query($query);
		$cate='';
		while($row = mysql_fetch_array($result))
			{
			// il faut grer l'affichage de la catgorie "ZZAutres services" en enlevant "ZZ" en dbut de la chane de caractre si il est repr
			$row_cat = preg_replace("/^Z{2}/", "", $row["cat"]);
			if ($row_cat!=$cate)
				{
				if ($cate!="") {$output.='</ul></div>';};
				$cate=$row_cat;
				$output.='<div align="left"><h2>'.$cate.'</h2><ul>';
				}
			$metacond=(($row["meta_id"]==0)?'<font color="red">pour tous</font>':'<font color="blue">modle</font>');
			$output .= "
			<li>
			<span class='user'><strong>".$row['title']."</strong> - (".$row['type'].", ".$row['param'].") - ".$metacond."</span>&nbsp;
			<span class='links'>
			<a href='#' title='Modifier' onclick=\"adminEditContenuMenu(".$row['id'].",'menu'); return false;\" >Modifier</a>
			&nbsp;|&nbsp;
			<a href='#' title='Supprimer' onclick=\"adminEditContenuMenu(".$row['id'].",'del'); return false;\" >Supprimer</a>
			</span>
			</li>";
			$query = "SELECT * FROM  ".PREFIX."ajaxp_menu ORDER BY torder";
			}
		$output .= "</ul></div>";
		}
	return $output;
	}

function editUser($type,$input1,$input2,$input3,$input4,$input5,$input6,$input7)
	{
	$input1 = security($input1);
	$input2 = security($input2);
	$input3 = security($input3);
	$input4 = security($input4);
	$input5 = security($input5);
	$input6 = security($input6);
	$input7 = security($input7);
	$userid = give_user_id($_SESSION['sess_userid']);
	switch($type)
		{
		case 'info':
		if(!empty($input1))
			{
			$query = "UPDATE  ".PREFIX."ajaxp_users SET firstname=\"$input1\",lastname=\"$input2\",email=\"$input3\" WHERE user_id=$userid";
			mysql_query($query);
			return 1;
			}
		$query = "SELECT * FROM  ".PREFIX."ajaxp_users WHERE user_id=$userid";
		$result = mysql_query($query);
		$row = mysql_fetch_array($result);
		$output = "<div class=\"header\">";
		$output .= "<h1>Informations sur le compte $_SESSION[sess_firstname] $_SESSION[sess_lastname]</h1></div>";
		$output .= "<form onsubmit='return editUser(\"info\",this)' method='get' action=''>\n";
		$output .= "<p>\n";
		$output .= "<strong>Prnom</strong><br/><input type='text' size='20' name='firstname' id='firstname' tabindex=1 value='$row[firstname]' /><br/>\n";
		$output .= "<strong>Nom</strong><br/><input type='text' size='20' name='lastname' id='lastname' tabindex=2 value='$row[lastname]' /><br/>\n";
		$output .= "<strong>Ml</strong><br/><input type='text' size='30' name='email' id='email' tabindex=3 value='$row[email]' /><br/><br/>\n";
		$output .= "
		<input type='submit' value='Sauvegarder' class='btn' />&nbsp;
		<input type='button' value='Annuler' onclick=\"switchPage('prefs'); return false;\" class='redbtn' />\n";
		$output .= "</p></form>";
		break;
		case 'settings':
		if(!empty($input1))
			{
			$query = "UPDATE  ".PREFIX."ajaxp_users SET theme_id=$input1 WHERE user_id=$userid";
			mysql_query($query);
			$_SESSION['sess_theme_id'] = $input1;
			return $input1;
			}
		$query = "SELECT * FROM  ".PREFIX."ajaxp_users WHERE user_id=$userid";
		$result = mysql_query($query);
		$row = mysql_fetch_array($result);
		$output = "<div class=\"header\">";
		$output .= "<h1>Prfrences de $_SESSION[sess_firstname] $_SESSION[sess_lastname]</h1></div>";
		$output .= "<form onsubmit='return editUser(\"settings\",this)' method='get' action=''>\n";
		$output .= "<p>\n";
		$output .= "<strong>Theme</strong><br/><select name='theme_id'>";
		$query2 = "SELECT * FROM  ".PREFIX."ajaxp_themes";
		$result2 = mysql_query($query2);
		while ($row2 = mysql_fetch_assoc($result2))
			{
			extract($row2);
			$output .= '<option value='.$row2['theme_id'].' '.($row['theme_id'] == $row2['theme_id'] ? "selected" : "").'>'.$row2['theme_name'].'</option>\n'; 
			}
		$output .= "</select><br/><br/>\n";
		$output .= "<input type='submit' value='Valider' class='btn' /> <input type='button' value='Annuler' onclick=\"switchPage('admin'); return false;\" class='redbtn' />\n";
		$output .= "</p></form>";
		break;
		case 'pass':
		if(!empty($input1))
			{
			$query = "UPDATE  ".PREFIX."ajaxp_users SET password=PASSWORD(\"$input2\") WHERE user_id=$userid";
			mysql_query($query);
			return 1;
			}
		$output = "<div class=\"header\">";
		$output .= "<h1>Mot de passe de $_SESSION[sess_firstname] $_SESSION[sess_lastname]</h1></div>";
		$output .= "<form onsubmit='return editUser(\"pass\",this)' method='get' action=''>\n";
		$output .= "<p>\n";
		$output .= "<strong>Nouveau mot de passe</strong><br/><input type='password' size='20' name='new_password' id='new_password'   /><br/><br/>\n";
		$output .= "<strong>Confirmation du mot de passe</strong><br/><input type='password' size='20' name='new_password2' id='new_password2'  /><br/><br/>\n";
		$output .= "<input type='submit' value='Changer le mot de passe' class='btn' /><input type='button' value='Annuler' onclick=\"switchPage('prefs'); return false;\" class='redbtn' />\n";
		$output .= "</p></form>";
		break;
		}
	return $output;
	}

function searchBoxes($terms,$option,$locations)
	{
	$terms = security($terms);
	if($locations==1)
		{
		// current ajaxp page
		$locs="sc.tid=".$_SESSION['page']." AND ";
		// current edp pages
		if(!empty($_SESSION['backends']))
			{
			foreach ($_SESSION['backends'] as $etable )
				{
				$result = mysql_query("SHOW TABLES FROM ".DBNAME." LIKE '%".PREFIX."ajaxp_edp_".$etable."%'");
				while ($row = mysql_fetch_row($result)) { $backendtables[]=$row[0]; }
				}
			}
		}
	else
		{
		$locs="";
		// all edp pages
		$result = mysql_query("SHOW TABLES FROM ".DBNAME." LIKE  '%".PREFIX."ajaxp_edp_%'");
		while ($row = mysql_fetch_row($result)) { $backendtables[]=$row[0]; }
		}
	// ajax pages
	$query="SELECT sc.tid, sc.title, sc.content, cy.title as ptitle FROM  ".PREFIX."ajaxp_boxes as sc, ".PREFIX."ajaxp_templates as cy  WHERE sc.tid = cy.id AND ".$locs;
	if($option == 'all') $query .= "(sc.title LIKE '%$terms%' OR sc.content LIKE '%$terms%')";
	elseif($option == 'title') $query .= "(sc.title LIKE '%$terms%')";
	elseif($option == 'content') $query .= "(sc.content LIKE '%$terms%')";
	$query .= " ORDER BY sc.tid,sc.title ";
	$result = mysql_query($query) or die ('MySQL connection failed. ' . mysql_error());
	$output1='';
	$countr = mysql_num_rows($result);
	$count=0;
	if($countr>0)
		{
		$pold='';
		while($row = mysql_fetch_array($result))
			{
			if(strpos($row['content'],"~~|~~")!==0)
				{
				if($pold!==$row['ptitle']) {$output1 .= '<p><h3><em>In '.$row['ptitle'].' Page</em></h3></p>';}
				$pold=$row['ptitle'];
				$count++;
				$output1 .= '
				<div class="modbox">
				<table border="0"  cellspacing="0" cellpadding="0"><tbody><tr>
				<td width="100%" class="mhdr"><div class="mttl"><img src=images/nuvola/16x16/actions/encrypted.png >'.$row['title'].'</div></td>
				<td class="medit"><a href="#" onclick="javascript:   makeRequest(\'ajaxp_backend.php\',\'?page='.$row['tid'].'\');" onmouseover="bgSwitch(\'on\', this);" onmouseout="bgSwitch(\'off\', this);" title="'.$row['ptitle'].'">'.$row['ptitle'].'</a> &raquo;&nbsp;&nbsp;</td>
				</tr></tbody></table>
				<div class="mc">
				<table border="0" cellpadding="3" cellspacing="0" align="center" width="100%"><tr><td  class="boxes"><p>'.$row['content'].'</p></td></tr></table>
				</div>
				</div>';
				}
			}
		}
	// edp pages
	if(!empty($backendtables))
		{
		foreach ($backendtables as $table )
			{
			$query="SELECT ID,Name,Description FROM  ".$table." WHERE ";
			if($option == 'all') $query .= "(Name LIKE '%$terms%' OR Description LIKE '%$terms%')";
			elseif($option == 'title') $query .= "(Name LIKE '%$terms%')";
			elseif($option == 'content') $query .= "(Description LIKE '%$terms%')";
			$query .= " ORDER BY Name,ID ";
			$result = mysql_query($query);
			$countr = mysql_num_rows($result);
			if($countr>0)
				{
				$pold=str_replace(PREFIX."ajaxp_edp_","",$table);
				$pold=ucfirst(str_replace("_"," ",$pold));
				$output1 .= "<p><h3><em>In Easy ".$pold."</h3></p>\n";
				while($row = mysql_fetch_array($result))
					{
					$count++;
					$output1 .= '
					<div class="modbox">
					<table  border="0"  cellspacing="0" cellpadding="0"><tbody><tr>
					<td width="100%" class="mhdr"><div class="mttl"><img src=images/nuvola/16x16/actions/encrypted.png >'.$row['Name'].'</div></td>
					<td class="medit"><a title="Close Box"  href="#"   onmouseover="bgSwitch(\'on\', this);" onmouseout="bgSwitch(\'off\', this);"  >&#215;</a>&nbsp;&nbsp;</td>
					</tr></tbody></table>
					<div class="mc">
					<table border="0" cellpadding="3" cellspacing="0" align="center" width="100%"><tr><td  class="boxes"><p>'.$row['Description'].'</p></td></tr></table>
					</div>
					</div>';
					}
				}
			}
		}
	$output  = "
	<table cellspacing=\"0\" border=\"0\" width=\"100%\">
	<tr>
	<td width=\"50\">&nbsp;</td>
	<td class=\"head\">
	<h2>Found $count Results for '$terms'</h2>
	<div class=right><a href=\"#\" onclick=\"switchPage('search'); return false;\" title=\"Begin a New Search\"><b>New Search</b></a></div>
	</td>
	<td width=\"50\"></td>
	</tr>";
	$output .= "
	<tr>
	<td width=\"50\">&nbsp;</td>
	<td>".$output1."</td>
	<td width=\"50\">&nbsp;</td>
	</tr>
	</table>";
	unset($output1);
	return $output;
	}

function registerADP($firstname,$lastname,$email,$username,$password,$password2)
	{
	$username = security($username);
	$error='';
	$output= '';
	if(!empty($firstname))
		{
		$query = "SELECT * FROM  ".PREFIX."ajaxp_users WHERE username=\"".$username."\"";
		$result = mysql_query($query);
		if(mysql_num_rows($result)>0)
			{
			// User exists
			$error = "Username '".$username."' already exists";
			$username = '';
			}
		else
			{
			$firstname = security($firstname);
			$lastname = security($lastname);
			$email = security($email);
			$password = security($password);
			$md5 = md5($username);
			$query = "INSERT INTO  ".PREFIX."ajaxp_users VALUES
					(NULL,\"".$username."\",\"".$firstname."\",\"".$lastname."\",
					PASSWORD(\"".$password."\"),1,NOW(),1,\"".$email."\",0,\"s\",0,\"$md5\")";
			if(mysql_query($query))
				{
				inituserboxes($username);
				$output .= '
				<div class="loginbox">
				<div id="header"><h1>Register AjaxDynamiPages User</h1></div>
				<p id="error">Your registered sucsessfully. Now you can login and use the system.</p><br/>
				Already Registered? <a href="#"  onclick="switchPage(\'login\'); return false;"  title="Already Registered?">Login</a>
				</div>';
				return $output;
				}
			else
				{
				$output .= $query."<br/>".mysql_error();
				}
			}
		}
	$output .= '
	<form name="newuser" id="newuser" action="" onsubmit="return registerADP(this)"  method="post">
	<div class="loginbox">
	<div id="header"><h1>Register AjaxDynamiPages User</h1>Please fill out everything...</div>
	<p id="error"></p>
	<p>
	First Name:<br/><input type="text" size="20" name="register[firstname]" id="firstname" value="'.($firstname ? $firstname : "").'" tabindex="1" /><br/><br/>
	Last Name:<br/><input type="text" size="20" name="register[lastname]" id="lastname" value="'.($lastname ? $lastname : "").'" tabindex="2" /><br/><br/>
	E-Mail Address:<br/><input type="text" size="30" name="register[email]" id="email" tabindex="3" value="'.$email.'" /><br/><br/>
	Desired Username:<br/><input type="text" size="15" name="register[new_username]" id="new_username" value="'.($username ? $username : "").'" tabindex="4" /><br/><br/>
	Password:<br/><input type="password" size="15" name="register[password]" id="password" value="'.($password ? $password : "").'"   tabindex="5" /><br/>
	Retype Password:<br/><input type="password" size="15" name="register[password2]" id="password2" value="'.($password2 ? $password2 : "").'"  tabindex="6" /><br/><br/><br/>
	</p>
	</div><br/>
	<input type="submit" value="Register!" class="btn" tabindex="7" /><br/>
	</div>
	</form><br/>
	Already Registered? <a href="#"  onclick="switchPage(\'login\'); return false;"  title="Already Registered? ">Login</a>
	</div>';
	return $output;
	}

//fonction devenue inutile depuis la CASsification du portail
/*function loginADP($username,$password,$remember)
	{
	global $rne;
	$username = security($username);
	$password = security($password);
	$badlogin = 1;
	if(isLoggedIn()) {return "Succes!";}
	if (eoleLogin($username,$password))
		{
		// if (false) {
		$query = "SELECT * FROM  ".PREFIX."ajaxp_users
				  WHERE username='$username' AND password=PASSWORD('$password') AND active=1 LIMIT 1";
		$result = mysql_query($query);
		if(mysql_num_rows($result) > 0)
			{
			$userinfo = mysql_fetch_array($result);
			$_SESSION['sess_username'] = security($userinfo['username']);
			$_SESSION['sess_rne'] = $rne;
			$_SESSION['sess_firstname'] = security($userinfo['firstname']);
			$_SESSION['sess_lastname'] = security($userinfo['lastname']);
			$_SESSION['sess_userid'] = security($userinfo['user_id'],3);
			$_SESSION['sess_statut'] = verif_statut_envole($userinfo['username']);
			$_SESSION['sess_metaid'] = security($userinfo['meta_id'],3);
			$_SESSION['sess_accesslevel'] = security($userinfo['accesslevel'],3);
			$_SESSION['sess_usermd5'] = security($userinfo['md5']);
			$_SESSION['sess_theme_id'] = security($userinfo['theme_id'],3);
			$_SESSION['sess_last_ip'] = $_SERVER['REMOTE_ADDR'];
			$_SESSION['sess_password'] = security($password);
			$_SESSION['sess_logged_in'] = 1;
			$query = "UPDATE  ".PREFIX."ajaxp_users SET last_login=NOW(), last_ip=\"".$_SERVER['REMOTE_ADDR']."\" WHERE user_id=".$_SESSION['sess_userid']."";
			mysql_query($query);
			if($remember==1) {$_SESSION['remember']=$userinfo['user_id'];}
			else {unset($_SESSION['remember']);}
			$badlogin = 0;
			
			//jml adds
			$query = "SELECT * FROM  ".PREFIX."ajaxp_templates WHERE hidden=0 AND user_id=".give_user_id($_SESSION['sess_userid'])." ORDER BY torder LIMIT 1";
			$result = mysql_query($query);
			$row = mysql_fetch_array($result);
			extract($row);
			$id=$row['id'];
			$title=$row['title'];
			$maxic=$row['maxic'];
			$_SESSION['page']=$id;
			$_SESSION['pagetitle']=$title;
			$_SESSION['wpage']=$wpage;
			$tempo=explode("~~|~~",$maxic);
			$maxic=$tempo[0];
			for($i=1; $i<count($tempo); $i++) { $cccica[]=$tempo[$i]; }
			//end jml adds
			
			return "Succes!";
			}
		else
			{
			$badlogin = 1;
			}
		}
	$output= '
	<div class="login">
	<form name="loginf"  onsubmit="return loginADP(this)"  action=""  method="POST">
	<div class="loginbox">
	<div id="header">
	<h1>Connexion EnvOLE</h1>';
	if($badlogin == 1)
		{
		$output .= "<span class=\"error\">Echec de connexion</span>\n";
		}
	$output .= '
	</div>
	<p>
	Identifiant:<br/>
	<input type="text" size="15" title="Entrez votre identifiant ici" name="username" value="'.$username.'"tabindex="1" /><br/>
	Mot de passe:<br/>
	<input type="password" size="15" title="Entrez votre mot de passe ici" name="password" value="'.$password.'"tabindex="2" /><br/><br/><input type="hidden" name="remember" value="0"></input>
	</p>
	</div><br/>&nbsp;
	<input type="submit" value="Connexion" class="btn" tabindex="4" /><br/><br/>
	</form>
	</div>';
	return $output;
	}*/

function passwordADP($email)
	{
	$error = '';
	$output = '';
	if(!empty($email))
		{
		if(sendPassword($email))
			{
			$error .= "A new password has been sent to: $email.";
			$output .= '
			<div class="login">
			<div class="loginbox">
			<div id="header">
			<h1>Ajax Portal Password Reminder</h1>
			</div>
			<p id="error">'.$error.'</p>
			</div><br/>
			Just Remembered It? <a href="#"  onclick="switchPage(\'login\'); return false;"  title="Login">Login</a>
			</div>';
			}
		else
			{
			$error .= "Email Address is not a valid account";
			$output .= '
			<div class="login">
			<form name="reminder" id="reminder" action="" onsubmit="return passwordADP(this)"  method="get">
			<div class="loginbox">
			<div id="header">
			<h1>Ajax Portal Password Reminder</h1>
			A new password will be sent to you.
			</div>
			<p id="error">'.$error.'</p>
			<p>Your E-Mail Address:<br/><input type="text" size="30" name="email" id="email" tabindex="3" value="'.$email.'" /><br/><br/></p>
			</div><br/>
			<input type="submit" value="Send Password" class="btn" tabindex="7" /><br/>
			</form>
			<br/>
			Just Remembered It? <a href="#"  onclick="switchPage(\'login\'); return false;"  title="Login">Login</a>
			</div>';
			}
		}
	return $output;
	}

// update template
function update_boxes($data)
	{
	if(!empty($_SESSION['sess_logged_in']) && $_SESSION['sess_logged_in']>0 )
		{
		$idid=$_SESSION['page'];
		$coma=explode(",",$data);
		$seq=explode(":",$coma[0]);
		$bid=explode(":",$coma[1]);
		$bi=explode(":",$coma[2]);
		$drag=explode(":",$coma[3]);
		mysql_query("UPDATE  ".PREFIX."ajaxp_boxes SET cid = '".security($drag[0],3)."' WHERE  bid='".security($drag[1],3)."' AND tid='".security($idid,3)."';");
		foreach($bi AS $ii)
			{
			mysql_query("UPDATE  ".PREFIX."ajaxp_boxes SET seq = '".security($seq[$ii],3)."' WHERE  bid='".security($bid[$ii],3)."' AND tid='".security($idid,3)."';");
			}
		return;
		}
	else
		{
		return;
		}
	}

// delete a box and its content
function delete_boxes($data)
	{
	mysql_query("DELETE FROM  ".PREFIX."ajaxp_boxes WHERE  bid='".security($data,3)."';");
	}

// edit box information
function changeText($TTxT,$sValue)
	{
	if(!isset($_SESSION['sess_logged_in']) || $_SESSION['sess_logged_in']!=1) return false;
	// decode data
	$sValue_array = explode("~~|~~", $sValue);
	$sCell = explode("_", $sValue_array[1]);
	// strip bad stuff
	$parsedInput=$sValue_array[0];
	$parsedInput =str_replace("\\","",$parsedInput);
	if($TTxT==0) $parsedInput = security($parsedInput,1);
	else $parsedInput = preg_replace('/(?:<script.*?>)((\n|\r|.)*?)(?:<\/script>)/','', $parsedInput); //traiter le javascript et laisser le html pour un contenu
	if(get_magic_quotes_gpc()) $parsedInput2 = stripslashes($parsedInput);
	$parsedInput2 = mysql_real_escape_string($parsedInput2);
	if ($sCell[0] && ($sCell[1]=="title" || $sCell[1]=="content"))
		{
		$sql = mysql_query("UPDATE  ".PREFIX."ajaxp_boxes SET ".security($sCell[1])."='".$parsedInput2."' WHERE bid='".security($sCell[0],3)."'");
		}
	// create string to return to the page
	if($TTxT==0)
		{
		$newText = ''.$parsedInput.'~~|~~'.$sValue_array[1];
		}
	else
		{
		$newText = '<div>'.$parsedInput.'</div>~~|~~'.$sValue_array[1];
		}
	return $newText;
	}

/*********************************************
              Sajax Setup
**********************************************/
//require_once('Sajax.php');
if (!isset($SAJAX_INCLUDED))
	{
	$sajax_debugapmode = 0;
	$sajax_export_list = array();
	$sajax_request_type = "GET";
	$sajax_remote_uri = "";
	
	function sajax_init() {}
	
	function sajax_get_my_uri() { global $REQUEST_URI; return $REQUEST_URI; }
	
	$sajax_remote_uri = sajax_get_my_uri();
	
	function sajax_get_js_repr($value)
		{
		$type = gettype($value);
		if ($type == "boolean" || $type == "integer") { return "parseInt($value)"; }
		elseif ($type == "double") { return "parseFloat($value)"; }
		elseif ($type == "array" || $type == "object" )
			{
			$s = "{ ";
			if ($type == "object") { $value = get_object_vars($value); }
			foreach ($value as $k=>$v)
				{
				$esc_key = sajaxapesc($k);
				if (is_numeric($k)) $s .= "$k: " . sajax_get_js_repr($v) . ", ";
				else $s .= "\"$esc_key\": " . sajax_get_js_repr($v) . ", ";
				}
			return substr($s, 0, -2) . " }";
			}
		else { $esc_val = sajaxapesc($value); $s = "\"$esc_val\""; return $s; }
		}

	function sajax_handle_client_request()
		{
		global $sajax_export_list;
		$mode = "";
		if (!empty($_GET["rs"])) $mode = "get";
		if (!empty($_POST["rs"])) $mode = "post";
		if (empty($mode)) return;
		$target = "";
		if ($mode == "get")
			{
			header ("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
			header ("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
			header ("Cache-Control: no-cache, must-revalidate");
			header ("Pragma: no-cache");
			$func_name = $_GET["rs"];
			if (! empty($_GET["rsargs"])) $args = $_GET["rsargs"];
			else $args = array();
			}
		else
			{
			$func_name = $_POST["rs"];
			if (! empty($_POST["rsargs"])) $args = $_POST["rsargs"];
			else $args = array();
			}
		if (! in_array($func_name, $sajax_export_list)) echo "-:$func_name not callable";
		else
			{
			echo "+:";
			$result = call_user_func_array($func_name, $args);
			echo "var res = " . sajax_get_js_repr($result) . "; res;";
			}
		exit;
		}

	function sajax_get_common_js()
		{
		global $sajax_debugapmode;
		global $sajax_request_type;
		global $sajax_remote_uri;
		$t = strtoupper($sajax_request_type);
		if ($t != "" && $t != "GET" && $t != "POST") return "// Invalid type: $t.. \n\n";
		ob_start();
		?>
        var sajax_debugapmode = <?php echo $sajax_debugapmode ? "true" : "false"; ?>;
        var sajax_request_type = "<?php echo $t; ?>";
        var sajax_target_id = "";
        
        function sajax_debug(text) { if (sajax_debugapmode) alert("RSD: " + text) }
        
        function sajax_init_object()
        	{
            sajax_debug("sajax_init_object() called..");
            var A;
            try { A=new ActiveXObject("Msxml2.XMLHTTP"); }
            catch (e)
            	{
                try { A=new ActiveXObject("Microsoft.XMLHTTP"); }
                catch (oc) { A=null; }
                }
            if(!A && typeof XMLHttpRequest != "undefined") A = new XMLHttpRequest();
            if (!A) sajax_debug("Could not create connection object.");
            return A;
            }

		function sajax_do_call(func_name, args)
        	{
            var i, x, n;
            var uri;
            var post_data;
            var target_id;
            sajax_debug("in sajax_do_call().." + sajax_request_type + "/" + sajax_target_id);
            target_id = sajax_target_id;
            if (sajax_request_type == "") sajax_request_type = "GET";
            uri = "<?php echo $sajax_remote_uri; ?>";
            if (sajax_request_type == "GET")
            	{
                if (uri.indexOf("?") == -1) uri += "?rs=" + escape(func_name);
                else uri += "&rs=" + escape(func_name);
                uri += "&rst=" + escape(sajax_target_id);uri += "&rsrnd=" + new Date().getTime();
                for (i = 0; i < args.length-1; i++) uri += "&rsargs[]=" + escape(args[i]);
                post_data = null;
                }
            else if (sajax_request_type == "POST")
            	{
                post_data = "rs=" + escape(func_name);
                post_data += "&rst=" + escape(sajax_target_id);
                post_data += "&rsrnd=" + new Date().getTime();
                for (i = 0; i < args.length-1; i++)  post_data = post_data + "&rsargs[]=" + escape(args[i]);
                }
            else {alert("Illegal request type: " + sajax_request_type);}
            x = sajax_init_object();
            x.open(sajax_request_type, uri, true);
            if (sajax_request_type == "POST")
            	{
                x.setRequestHeader("Method", "POST " + uri + " HTTP/1.1");
                x.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
                }
            x.onreadystatechange = function()
            	{
                if (x.readyState != 4) return;
                sajax_debug("received " + x.responseText);
                var status;
                var data;
                status = x.responseText.charAt(0);
                data = x.responseText.substring(2);
                if (status == "-")  alert("Error: " + data);
                else
                	{
                    if (target_id != "") document.getElementById(target_id).innerHTML = eval(data);
                    else args[args.length-1](eval(data));
                    }
                };
            sajax_debug(func_name + " uri = " + uri + "/post = " + post_data);
            x.send(post_data);
            sajax_debug(func_name + " waiting..");
            delete x;
            return true;
            }

		<?php
        $html = ob_get_contents();
		ob_end_clean();
		return $html;
		}
	
	function sajax_show_common_js() {echo sajax_get_common_js();}
	
	function sajaxapesc($val)
		{
		$val = str_replace("\\", "\\\\", $val);
		$val = str_replace("\r", "\\r", $val);
		$val = str_replace("\n", "\\n", $val);
		return str_replace('"', '\\"', $val);
		}

	function sajax_get_one_stub($func_name)
		{
		ob_start();
		?>
        function x_<?php echo $func_name; ?>()
        	{
            sajax_do_call("<?php echo $func_name; ?>", x_<?php echo $func_name; ?>.arguments);
            }
		<?php
        $html = ob_get_contents();
		ob_end_clean();
		return $html;
		}
	
	function sajax_show_one_stub($func_name) {echo sajax_get_one_stub($func_name);}
	
	function sajax_export()
		{
		global $sajax_export_list;
		$n = func_num_args();
		for ($i = 0; $i < $n; $i++) { $sajax_export_list[] = func_get_arg($i); }
		}

	$sajax_js_has_been_shown = 0;
	
	function sajax_get_javascript()
		{
		global $sajax_js_has_been_shown;
		global $sajax_export_list;
		$html = "";
		if (! $sajax_js_has_been_shown)
			{
			$html .= sajax_get_common_js();
			$sajax_js_has_been_shown = 1;
			}
		foreach ($sajax_export_list as $func) { $html .= sajax_get_one_stub($func); }
		return $html;
		}

	function sajax_show_javascript() { echo sajax_get_javascript(); }
	$SAJAX_INCLUDED = 1;
	}

$sajax_request_type = "POST";
$sajax_remote_uri = 'ajaxp_backend.php';
sajax_init();
$sajax_debugapmode = 0;
sajax_export("setEleve","getImgSharebox","delete_boxes","update_boxes","changeText","getUser","adpLookup","buildBreadcrumb","searchBoxes","editUser","editSettings","adminEditUsers","adminEditContenuMenu","adminAddContenuMenu","adminAddUser","loginADP","registerADP","passwordADP","changePWD");
sajax_handle_client_request();
?>
