<?php
/**
 * Piwik - Open source web analytics
 * 
 * @link http://piwik.org
 * @license http://www.gnu.org/licenses/gpl-3.0.html Gpl v3 or later
 * @version $Id: index.php 539 2008-06-29 22:05:21Z matt $
 * 
 * @package Piwik
 */

// NOTE: This file should be PHP4 compatible
error_reporting(E_ALL|E_NOTICE);
@ini_set('display_errors', 1);
@ini_set('magic_quotes_runtime', 0);
if(!defined('PIWIK_INCLUDE_PATH'))
{
	define('PIWIK_INCLUDE_PATH', dirname(__FILE__));
}

set_include_path(PIWIK_INCLUDE_PATH 
					. PATH_SEPARATOR . PIWIK_INCLUDE_PATH . '/libs/'
					. PATH_SEPARATOR . PIWIK_INCLUDE_PATH . '/plugins/'
					. PATH_SEPARATOR . PIWIK_INCLUDE_PATH . '/modules/'
					. PATH_SEPARATOR . get_include_path());

require_once "modules/testMinimumPhpVersion.php";

date_default_timezone_set(date_default_timezone_get());

if(!defined('ENABLE_DISPATCH'))
{
	define('ENABLE_DISPATCH', true);	
}

/**
 * Error / exception handling functions
 */
require_once "modules/ErrorHandler.php";
require_once "modules/ExceptionHandler.php";
set_error_handler('Piwik_ErrorHandler');
set_exception_handler('Piwik_ExceptionHandler');

if(strlen(session_id()) === 0)
{
	session_start();
}

require_once "FrontController.php";

if(ENABLE_DISPATCH)
{
	$controller = Piwik_FrontController::getInstance();
	$controller->init();
	$controller->dispatch();
}
